# All batteries
Source: https://developer.energy-hub.io/api-reference/battery-controller/all-batteries
get /v1.0.0/batteries
Returns a paginated and searchable list of all batteries of subscription.Supports filtering by UUID, user ID, online status, name, vendor, model, last updated date and charging state Text searches are case-insensitive and support partial matching.
# Delete battery
Source: https://developer.energy-hub.io/api-reference/battery-controller/delete-battery
delete /v1.0.0/batteries/{batteryId}
Deletes the battery.
# Get battery data
Source: https://developer.energy-hub.io/api-reference/battery-controller/get-battery-data
get /v1.0.0/batteries/{batteryId}
Returns general data of a single battery.
# Refresh battery data
Source: https://developer.energy-hub.io/api-reference/battery-controller/refresh-battery-data
get /v1.0.0/batteries/{batteryId}/refresh
Updates battery with newest data from vendor system.
# All chargers
Source: https://developer.energy-hub.io/api-reference/charger-controller/all-chargers
get /v1.0.0/chargers
Returns a paginated and searchable list of all chargers of subscription.Supports filtering by UUID, user ID, online status, name, vendor, model, and last updated date. Text searches are case-insensitive and support partial matching.
# Charger commands
Source: https://developer.energy-hub.io/api-reference/charger-controller/charger-commands
get /v1.0.0/chargers/{chargerId}/commands
Returns pending commands for charger
# Charger data
Source: https://developer.energy-hub.io/api-reference/charger-controller/charger-data
get /v1.0.0/chargers/{chargerId}
Returns general data of a single charger.
# Delete charger
Source: https://developer.energy-hub.io/api-reference/charger-controller/delete-charger
delete /v1.0.0/chargers/{chargerId}
Deletes the charger.
# Refresh charger data
Source: https://developer.energy-hub.io/api-reference/charger-controller/refresh-charger-data
get /v1.0.0/chargers/{chargerId}/refresh
Updates charger with newest data from vendor system.
# Submit command to control the amount of charging power
Source: https://developer.energy-hub.io/api-reference/charger-controller/submit-command-to-control-the-amount-of-charging-power
post /v1.0.0/chargers/{chargerId}/commands/charging-current
This endpoint creates an asynchronously executed command request to control the amount of charging power.
# Submit command to control the number of active phases during charging
Source: https://developer.energy-hub.io/api-reference/charger-controller/submit-command-to-control-the-number-of-active-phases-during-charging
post /v1.0.0/chargers/{chargerId}/commands/charging-phases
This endpoint creates an asynchronously executed command request to control the number of active phases during charging.
# Submit command to start charging
Source: https://developer.energy-hub.io/api-reference/charger-controller/submit-command-to-start-charging
post /v1.0.0/chargers/{chargerId}/commands/charging-start
This endpoint creates an asynchronously executed command request to start charging.
# Submit command to stop charging
Source: https://developer.energy-hub.io/api-reference/charger-controller/submit-command-to-stop-charging
post /v1.0.0/chargers/{chargerId}/commands/charging-stop
This endpoint creates an asynchronously executed command request to stop charging.
# Link chargers
Source: https://developer.energy-hub.io/api-reference/charger-link-controller/link-chargers
post /v1.0.0/link/users/{userId}/vendor-accounts/{vendorAccountId}/chargers
Connects the provided list of chargers from the vendor account to the Energy Hub.
# List chargers from vendor
Source: https://developer.energy-hub.io/api-reference/charger-link-controller/list-chargers-from-vendor
get /v1.0.0/link/users/{userId}/vendor-accounts/{vendorAccountId}/chargers
Returns connected chargers for the vendor account directly from vendor system.
# Get all available vendors
Source: https://developer.energy-hub.io/api-reference/connection-controller/all-available-vendors
get /v1.0.0/connections/available-vendors
Returns available-vendors data for specific partner
# Connect URL for a charger vendor
Source: https://developer.energy-hub.io/api-reference/connection-controller/connect-url-for-a-ev-charger-vendor
post /v1.0.0/connections/chargers
Creates a connect URL to redirect to the IDP of the specified charger vendor.
# Connect URL for a home power vendor
Source: https://developer.energy-hub.io/api-reference/connection-controller/connect-url-for-a-home-power-vendor
post /v1.0.0/connections/home-powers
Creates a connect URL to redirect to the IDP of the specified home power vendor.
# Connect URL for a HVAC vendor
Source: https://developer.energy-hub.io/api-reference/connection-controller/connect-url-for-a-hvac-vendor
post /v1.0.0/connections/hvacs
Creates a connect URL to redirect to the IDP of the specified HVAC vendor.
# Connect URL for a tariff vendor
Source: https://developer.energy-hub.io/api-reference/connection-controller/connect-url-for-a-tariff-vendor
post /v1.0.0/connections/tariffs
Creates a connect URL to redirect to the IDP of the specified tariff vendor.
# Connect URL for a vehicle vendor
Source: https://developer.energy-hub.io/api-reference/connection-controller/connect-url-for-a-vehicle-vendor
post /v1.0.0/connections/vehicles
Creates a connect Url to redirect to the IDP of the specified vehicle vendor.
# Link batteries
Source: https://developer.energy-hub.io/api-reference/home-power-link-controller/link-batteries
post /v1.0.0/link/users/{userId}/vendor-accounts/{vendorAccountId}/batteries
Connects the provided list of batteries from the vendor account to the Energy Hub.
# Link meters
Source: https://developer.energy-hub.io/api-reference/home-power-link-controller/link-meters
post /v1.0.0/link/users/{userId}/vendor-accounts/{vendorAccountId}/meters
Connects the provided list of meters from the vendor account to the Energy Hub.
# Link PV inverters
Source: https://developer.energy-hub.io/api-reference/home-power-link-controller/link-pv-inverters
post /v1.0.0/link/users/{userId}/vendor-accounts/{vendorAccountId}/pv-inverters
Connects the provided list of PV inverters from the vendor account to the Energy Hub.
# List batteries from vendor
Source: https://developer.energy-hub.io/api-reference/home-power-link-controller/list-batteries-from-vendor
get /v1.0.0/link/users/{userId}/vendor-accounts/{vendorAccountId}/batteries
Returns connected batteries for the vendor account directly from vendor system.
# List meters from vendor
Source: https://developer.energy-hub.io/api-reference/home-power-link-controller/list-meters-from-vendor
get /v1.0.0/link/users/{userId}/vendor-accounts/{vendorAccountId}/meters
Returns connected meters for the vendor account directly from vendor system.
# List PV inverters from vendor
Source: https://developer.energy-hub.io/api-reference/home-power-link-controller/list-pv-inverters-from-vendor
get /v1.0.0/link/users/{userId}/vendor-accounts/{vendorAccountId}/pv-inverters
Returns connected PV inverters for the vendor account directly from vendor system.
# All HVACs
Source: https://developer.energy-hub.io/api-reference/hvac-controller/all-hvacs
get /v1.0.0/hvacs
Returns a paginated and searchable list of all hvac's of the subscription. Supports filtering by UUID, user ID, online status, name, vendor, model, last updated date and type. Text searches are case-insensitive and support partial matching.
# All schedules by HVAC
Source: https://developer.energy-hub.io/api-reference/hvac-controller/all-schedules-by-hvac
get /v1.0.0/hvacs/{hvacId}/schedules
Returns all schedules by HVAC.
# Delete HVAC
Source: https://developer.energy-hub.io/api-reference/hvac-controller/delete-hvac
delete /v1.0.0/hvacs/{hvacId}
Deletes the HVAC.
# HVAC commands
Source: https://developer.energy-hub.io/api-reference/hvac-controller/hvac-commands
get /v1.0.0/hvacs/{hvacId}/commands
Returns pending commands for HVAC
# HVAC data
Source: https://developer.energy-hub.io/api-reference/hvac-controller/hvac-data
get /v1.0.0/hvacs/{hvacId}
Returns general data of a single HVAC.
# Refresh HVAC data
Source: https://developer.energy-hub.io/api-reference/hvac-controller/refresh-hvac-data
get /v1.0.0/hvacs/{hvacId}/refresh
Updates HVAC with newest data from vendor system.
# Submit command to change mode of HVAC
Source: https://developer.energy-hub.io/api-reference/hvac-controller/submit-command-to-change-mode-of-hvac
post /v1.0.0/hvacs/{hvacId}/commands/mode
This endpoint creates an asynchronously executed command request to change the mode of HVAC.
# Submit command to change schedule of HVAC
Source: https://developer.energy-hub.io/api-reference/hvac-controller/submit-command-to-change-schedule-of-hvac
post /v1.0.0/hvacs/{hvacId}/commands/schedule
This endpoint creates an asynchronously executed command request to change schedule of HVAC.
# Submit command to change temperature of HVAC
Source: https://developer.energy-hub.io/api-reference/hvac-controller/submit-command-to-change-temperature-of-hvac
post /v1.0.0/hvacs/{hvacId}/commands/temperature
This endpoint creates an asynchronously executed command request to change temperature of HVAC.
# Link HVACs
Source: https://developer.energy-hub.io/api-reference/hvac-link-controller/link-hvacs
post /v1.0.0/link/users/{userId}/vendor-accounts/{vendorAccountId}/hvacs
Connects the provided list of HVACs from the vendor account to the Energy Hub.
# List HVACs from vendor
Source: https://developer.energy-hub.io/api-reference/hvac-link-controller/list-hvacs-from-vendor
get /v1.0.0/link/users/{userId}/vendor-accounts/{vendorAccountId}/hvacs
Returns connected HVACs for the vendor account directly from vendor system.
# Authentication
Source: https://developer.energy-hub.io/api-reference/introduction/authentication
To interact with the Energy Hub Alliance API, you need need an API-key.
API-keys can be generated in the partner portal. One subscription can have several API-keys, so you can generate multiple keys for different applications.
We recommend to store the API-keys savely, since all data a the related subscription can be access trough this key.
# Errors
Source: https://developer.energy-hub.io/api-reference/introduction/errors
List of all errors and where they occur.
The Energy Hub Alliance uses error codes to indicate success or failure of API requests. HTTP status codes are used to indicate where things went wrong.
* **2XX:** indicates success
* **4XX:** indicates an invalid request (e.g. a required variable is missing from the request body)
* **5XX:** indicates that somethings went wrong on Energy Hub Alliance side (e.g. device is not capable of fulfilling a request).
# Common error codes
| Error code | Reason | HTTP status |
| ------------------------------------ | ------------------------------------------------------------------------ | ----------- |
| BAD\_REQUEST | Bad request | 400 |
| VARIABLE\_MUST\_NOT\_BE\_BLANK | Path variable is not present | 400 |
| METHOD\_ARGUMENT\_TYPE\_MISMATCH | Failed to convert value to required type | 400 |
| MISSING\_REQUEST\_PARAMETER | Required request parameter is not present | 400 |
| MISSING\_REQUEST\_PART | Required request part is not present | 400 |
| MAXIMUM\_UPLOAD\_SIZE\_EXCEEDED | Maximum upload size exceeded | 400 |
| UNAUTHORIZED | Unauthorized | 401 |
| VENDOR\_ACCOUNT\_NOT\_FOUND | Requested vendor account is not found. | 404 |
| METHOD\_NOT\_ALLOWED | Request HTTP method is not supported | 405 |
| UNSUPPORTED\_MEDIA\_TYPE | Media type is not supported | 415 |
| TOO\_MANY\_REQUESTS | Too many requests | 429 |
| INTERNAL\_SERVER\_ERROR | An error occurred | 500 |
| NOT\_IMPLEMENTED | Work in progress | 501 |
| VENDOR\_IMPLEMENTATION\_IN\_PROGRESS | Vendor feature implementation in progress | 501 |
| VENDOR\_CONNECTION\_ERROR | Connection cannot be established with Vendor API | 503 |
| VENDOR\_AUTHENTICATION\_ERROR | Authentication error with Vendor API | 503 |
| VENDOR\_COMMUNICATION\_ERROR | Communication error with Vendor API | 503 |
| VENDOR\_ACCOUNT\_IS\_DISCONNECTED | Vendor account is disconnected | 503 |
| TOO\_MANY\_REQUESTS | Too many requests | 429 |
| DEVICE\_LIMIT\_REACHED | Device limit reached | 402 |
| DEVICE\_IS\_DISCONNECTED | Device disconnected | 503 |
| DEVICE\_IMAGE\_NOT\_FOUND | Device image not found | 404 |
| USER\_ACTION\_NEEDED | A vendor-specific user action is needed in order to execute this request | 403 |
The response with the error code BAD\_REQUEST may contain the field validationErrors. This field includes the list of fields that failed the validation check with the error message for each field.
# Service specific error codes
| Error code | Reason | Device Type | HTTP status |
| ----------------------------------- | ------------------------------------------------------------------------------------------- | ----------- | ----------- |
| USER\_LINK\_NOT\_FOUND | User link not found. | CONNECT | 404 |
| REDIRECT\_URL\_NOT\_MATCHING | Provided redirect url does not match partner management redirect url. | CONNECT | 409 |
| VENDOR\_DISABLED | Provided vendor has been disabled and is no longer valid. | CONNECT | 400 |
| TELEMATICS\_NOT\_SUPPORTED | Vehicle does not support telematics | CONNECT | 422 |
| VENDOR\_NOT\_SUPPORTED | Provided vendor is not supported for partner | CONNECT | 403 |
| LOCATION\_NOT\_FOUND | Requested Location not found | LOCATION | 404 |
| TARIFF\_NOT\_FOUND | Tariff not found. | TARIFF | 404 |
| VEHICLE\_NOT\_FOUND | Requested Vehicle not found | VEHICLE | 404 |
| VEHICLE\_IMAGE\_NOT\_FOUND | Vehicle image not found | VEHICLE | 404 |
| VIN\_NOT\_FOUND | VIN not found | VEHICLE | 404 |
| COMMAND\_REQUEST\_NOT\_IMPLEMENTED | Submitting command request is not implemented | VEHICLE | 501 |
| COMMAND\_NOT\_FOUND | Vehicle command not found | VEHICLE | 404 |
| COMMAND\_TYPE\_NOT\_ALLOWED | Command type for this vehicle is not allowed | VEHICLE | 409 |
| ONLY\_ONE\_SCHEDULE\_ALLOWED | Only one schedule allowed | VEHICLE | 400 |
| SCHEDULE\_DAYS\_NOT\_SUPPORTED | Scheduling days not supported | VEHICLE | 400 |
| COMMANDS\_CURRENTLY\_NOT\_AVAILABLE | Commands are not available, possibly due to vehicle not being at the specified home address | VEHICLE | 400 |
| COMMAND\_ALREADY\_SUBMITTED | Command has already been submitted | VEHICLE | 409 |
| COMMAND\_NOT\_SUPPORTED | Submitting command is not supported | VEHICLE | 501 |
| HVAC\_NOT\_FOUND | HVAC not found | HVAC | 404 |
| HVAC\_SCHEDULES\_NOT\_AVAILABLE | HVAC schedules not available | HVAC | 404 |
| HVAC\_IMAGE\_NOT\_FOUND | Hvac image not found | HVAC | 409 |
| COMMAND\_REQUEST\_NOT\_IMPLEMENTED | Submitting command request is not implemented | HVAC | 501 |
| COMMAND\_NOT\_FOUND | HVAC command not found | HVAC | 404 |
| COMMAND\_TYPE\_NOT\_ALLOWED | Command type for this HVAC is not allowed | HVAC | 409 |
| INVALID\_VENDOR\_COMMAND\_VALUES | Values given for the command are invalid for this vendor | HVAC | 409 |
| UNSUPPORTED\_MODE | Specified vendor does not support this operation mode | HVAC | 400 |
| INVALID\_COMMAND\_DEVICE | This command is not supported for this type of device | HVAC | 400 |
| COMMAND\_ALREADY\_SUBMITTED | Command has already been submitted | HVAC | 409 |
| CHARGER\_NOT\_FOUND | Requested Charger not found | CHARGER | 404 |
| COMMAND\_REQUEST\_NOT\_IMPLEMENTED | Submitting command request is not implemented | CHARGER | 501 |
| COMMAND\_NOT\_FOUND | Charger command not found | CHARGER | 404 |
| COMMAND\_TYPE\_NOT\_ALLOWED | Command type for this charger is not allowed | CHARGER | 409 |
| INVALID\_VENDOR\_COMMAND\_VALUES | Values given for the command are invalid | CHARGER | 400 |
| COMMAND\_ALREADY\_SUBMITTED | Command has already been submitted | CHARGER | 409 |
| PV\_INVERTER\_NOT\_FOUND | Requested PV inverter not found | HOME\_POWER | 404 |
| BATTERY\_NOT\_FOUND | Battery not found | HOME\_POWER | 404 |
| METER\_NOT\_FOUND | Meter not found | HOME\_POWER | 404 |
# All meters
Source: https://developer.energy-hub.io/api-reference/meter-controller/all-meters
get /v1.0.0/meters
Returns a paginated and searchable list of all meters of subscription. Supports filtering by UUID, user ID, online status, name, vendor, model, and last updated date. Text searches are case-insensitive and support partial matching.
# Delete meter
Source: https://developer.energy-hub.io/api-reference/meter-controller/delete-meter
delete /v1.0.0/meters/{meterId}
Deletes the meter.
# Get meter data
Source: https://developer.energy-hub.io/api-reference/meter-controller/get-meter-data
get /v1.0.0/meters/{meterId}
Returns general data of a single meter.
# Refresh meter data
Source: https://developer.energy-hub.io/api-reference/meter-controller/refresh-meter-data
get /v1.0.0/meters/{meterId}/refresh
Updates meter with newest data from vendor system.
# All PV inverters
Source: https://developer.energy-hub.io/api-reference/pv-inverter-controller/all-pv-inverters
get /v1.0.0/pv-inverters
Returns a paginated and searchable list of all pv inverters of subscription.Supports filtering by UUID, user ID, online status, name, vendor, model, and last updated date. Text searches are case-insensitive and support partial matching.
# Delete PV inverter
Source: https://developer.energy-hub.io/api-reference/pv-inverter-controller/delete-pv-inverter
delete /v1.0.0/pv-inverters/{pvInverterId}
Deletes the PV inverter.
# PV inverter data
Source: https://developer.energy-hub.io/api-reference/pv-inverter-controller/pv-inverter-data
get /v1.0.0/pv-inverters/{pvInverterId}
Returns PV inverter data of a single PV inverter.
# Refresh PV inverter data
Source: https://developer.energy-hub.io/api-reference/pv-inverter-controller/refresh-pv-inverter-data
get /v1.0.0/pv-inverters/{pvInverterId}/refresh
Updates PV inverter with newest data from vendor system.
# All tariffs
Source: https://developer.energy-hub.io/api-reference/tariff-controller/all-tariffs
get /v1.0.0/tariffs
Returns a paginated list of all tariffs of subscription. Supports filtering by UUID, user ID, online status, vehicle name, vendor, model, and last updated date. Text searches are case-insensitive and support partial matching.
# Consumption
Source: https://developer.energy-hub.io/api-reference/tariff-controller/consumption
get /v1.0.0/tariffs/{tariffId}/consumption
Returns a paginated list of consumption of a tariff in hourly periods. The list is sorted in the way that the latest records are shown first.
# Delete tariff
Source: https://developer.energy-hub.io/api-reference/tariff-controller/delete-tariff
delete /v1.0.0/tariffs/{tariffId}
Deletes the tariff.
# Prices
Source: https://developer.energy-hub.io/api-reference/tariff-controller/prices
get /v1.0.0/tariffs/{tariffId}/prices
Returns prices of a tariff.
# Tariff data
Source: https://developer.energy-hub.io/api-reference/tariff-controller/tariff-data
get /v1.0.0/tariffs/{tariffId}
Returns general data of a single tariff.
# All batteries for user
Source: https://developer.energy-hub.io/api-reference/user-battery-controller/all-batteries-for-user
get /v1.0.0/users/{userId}/batteries
Returns a paginated list of all batteries that belong to the user.
# Battery data for user
Source: https://developer.energy-hub.io/api-reference/user-battery-controller/battery-data-for-user
get /v1.0.0/users/{userId}/batteries/{batteryId}
Returns general data of a single battery for the user.
# Delete battery for user
Source: https://developer.energy-hub.io/api-reference/user-battery-controller/delete-battery-for-user
delete /v1.0.0/users/{userId}/batteries/{batteryId}
Deletes the battery for the user.
# Refresh battery data for user
Source: https://developer.energy-hub.io/api-reference/user-battery-controller/refresh-battery-data-for-user
get /v1.0.0/users/{userId}/batteries/{batteryId}/refresh
Updates battery with newest data from vendor system for the user.
# All chargers for user
Source: https://developer.energy-hub.io/api-reference/user-charger-controller/all-chargers-for-user
get /v1.0.0/users/{userId}/chargers
Returns a paginated list of all chargers that belong to the user.
# Charger commands
Source: https://developer.energy-hub.io/api-reference/user-charger-controller/charger-commands
get /v1.0.0/users/{userId}/chargers/{chargerId}/commands
Returns pending commands for charger
# Charger data for user
Source: https://developer.energy-hub.io/api-reference/user-charger-controller/charger-data-for-user
get /v1.0.0/users/{userId}/chargers/{chargerId}
Returns general data of a single charger for the user.
# Delete charger for user
Source: https://developer.energy-hub.io/api-reference/user-charger-controller/delete-charger-for-user
delete /v1.0.0/users/{userId}/chargers/{chargerId}
Deletes the charger for the user.
# Refresh charger data for user
Source: https://developer.energy-hub.io/api-reference/user-charger-controller/refresh-charger-data-for-user
get /v1.0.0/users/{userId}/chargers/{chargerId}/refresh
Updates charger with newest data from vendor system for the user.
# Submit command to control the amount of charging power
Source: https://developer.energy-hub.io/api-reference/user-charger-controller/submit-command-to-control-the-amount-of-charging-power
post /v1.0.0/users/{userId}/chargers/{chargerId}/commands/charging-current
This endpoint creates an asynchronously executed command request to control the amount of charging power.
# Submit command to control the number of active phases during charging
Source: https://developer.energy-hub.io/api-reference/user-charger-controller/submit-command-to-control-the-number-of-active-phases-during-charging
post /v1.0.0/users/{userId}/chargers/{chargerId}/commands/charging-phases
This endpoint creates an asynchronously executed command request to control the number of active phases during charging.
# Submit command to start charging
Source: https://developer.energy-hub.io/api-reference/user-charger-controller/submit-command-to-start-charging
post /v1.0.0/users/{userId}/chargers/{chargerId}/commands/charging-start
This endpoint creates an asynchronously executed command request to start charging.
# Submit command to stop charging
Source: https://developer.energy-hub.io/api-reference/user-charger-controller/submit-command-to-stop-charging
post /v1.0.0/users/{userId}/chargers/{chargerId}/commands/charging-stop
This endpoint creates an asynchronously executed command request to stop charging.
# Delete all user devices and data
Source: https://developer.energy-hub.io/api-reference/user-controller/delete-all-user-devices-and-data
delete /v1.0.0/user/{userId}
Send notification for deletion of all user devices and data
# All HVACs for user
Source: https://developer.energy-hub.io/api-reference/user-hvac-controller/all-hvacs-for-user
get /v1.0.0/users/{userId}/hvacs
Returns a paginated list of all HVACs that belong to the user.
# All schedules by user and HVAC
Source: https://developer.energy-hub.io/api-reference/user-hvac-controller/all-schedules-by-user-and-hvac
get /v1.0.0/users/{userId}/hvacs/{hvacId}/schedules
Returns all schedules by user and HVAC.
# Delete HVAC for user
Source: https://developer.energy-hub.io/api-reference/user-hvac-controller/delete-hvac-for-user
delete /v1.0.0/users/{userId}/hvacs/{hvacId}
Deletes the HVAC for the user.
# HVAC commands
Source: https://developer.energy-hub.io/api-reference/user-hvac-controller/hvac-commands
get /v1.0.0/users/{userId}/hvacs/{hvacId}/commands
Returns pending commands for HVAC
# HVAC data for user
Source: https://developer.energy-hub.io/api-reference/user-hvac-controller/hvac-data-for-user
get /v1.0.0/users/{userId}/hvacs/{hvacId}
Returns general data of a single HVAC for the user.
# Refresh HVAC data for user
Source: https://developer.energy-hub.io/api-reference/user-hvac-controller/refresh-hvac-data-for-user
get /v1.0.0/users/{userId}/hvacs/{hvacId}/refresh
Updates HVAC with newest data from vendor system for the user.
# Submit command to change mode of HVAC
Source: https://developer.energy-hub.io/api-reference/user-hvac-controller/submit-command-to-change-mode-of-hvac
post /v1.0.0/users/{userId}/hvacs/{hvacId}/commands/mode
This endpoint creates a command request that is asynchronously executed.
# Submit command to change schedule of HVAC
Source: https://developer.energy-hub.io/api-reference/user-hvac-controller/submit-command-to-change-schedule-of-hvac
post /v1.0.0/users/{userId}/hvacs/{hvacId}/commands/schedule
This endpoint creates a command request that is asynchronously executed.
# Submit command to change temperature of HVAC
Source: https://developer.energy-hub.io/api-reference/user-hvac-controller/submit-command-to-change-temperature-of-hvac
post /v1.0.0/users/{userId}/hvacs/{hvacId}/commands/temperature
This endpoint creates a command request that is asynchronously executed.
# All meters for user
Source: https://developer.energy-hub.io/api-reference/user-meter-controller/all-meters-for-user
get /v1.0.0/users/{userId}/meters
Returns a paginated list of all meters that belong to the user.
# Delete meter for user
Source: https://developer.energy-hub.io/api-reference/user-meter-controller/delete-meter-for-user
delete /v1.0.0/users/{userId}/meters/{meterId}
Deletes the meter for the user.
# Meter data for user
Source: https://developer.energy-hub.io/api-reference/user-meter-controller/meter-data-for-user
get /v1.0.0/users/{userId}/meters/{meterId}
Returns general data of a single meter for the user.
# Refresh meter data for user
Source: https://developer.energy-hub.io/api-reference/user-meter-controller/refresh-meter-data-for-user
get /v1.0.0/users/{userId}/meters/{meterId}/refresh
Updates meter with newest data from vendor system for the user.
# All PV inverters for user
Source: https://developer.energy-hub.io/api-reference/user-pv-inverter-controller/all-pv-inverters-for-user
get /v1.0.0/users/{userId}/pv-inverters
Returns a paginated list of all PV inverters for the user.
# Delete PV inverter for user
Source: https://developer.energy-hub.io/api-reference/user-pv-inverter-controller/delete-pv-inverter-for-user
delete /v1.0.0/users/{userId}/pv-inverters/{pvInverterId}
Deletes the PV inverter for the user.
# PV inverter data for user
Source: https://developer.energy-hub.io/api-reference/user-pv-inverter-controller/pv-inverter-data-for-user
get /v1.0.0/users/{userId}/pv-inverters/{pvInverterId}
Returns PV inverter data of a single PV inverter for the user.
# Refresh PV inverter data for user
Source: https://developer.energy-hub.io/api-reference/user-pv-inverter-controller/refresh-pv-inverter-data-for-user
get /v1.0.0/users/{userId}/pv-inverters/{pvInverterId}/refresh
Updates PV inverter with newest data from vendor system for the user.
# All tariffs for user
Source: https://developer.energy-hub.io/api-reference/user-tariff-controller/all-tariffs-for-user
get /v1.0.0/users/{userId}/tariffs
Returns a paginated list of all tariffs that belong to the user.
# Consumption for user
Source: https://developer.energy-hub.io/api-reference/user-tariff-controller/consumption-for-user
get /v1.0.0/users/{userId}/tariffs/{tariffId}/consumption
Returns a paginated list of consumption of a tariff in hourly periods for the user.The list is sorted in the way that the latest records are shown first.
# Delete tariff for user
Source: https://developer.energy-hub.io/api-reference/user-tariff-controller/delete-tariff-for-user
delete /v1.0.0/users/{userId}/tariffs/{tariffId}
Deletes the tariff for the user.
# Prices for user
Source: https://developer.energy-hub.io/api-reference/user-tariff-controller/prices-for-user
get /v1.0.0/users/{userId}/tariffs/{tariffId}/prices
Returns prices of a tariff for the user.
# Tariff data for user
Source: https://developer.energy-hub.io/api-reference/user-tariff-controller/tariff-data-for-user
get /v1.0.0/users/{userId}/tariffs/{tariffId}
Returns general data of a single tariff for the user.
# All vehicles for user
Source: https://developer.energy-hub.io/api-reference/user-vehicle-controller/all-vehicles-for-user
get /v1.0.0/users/{userId}/vehicles
Returns a paginated list of all vehicles for the user.
# Delete vehicle for user
Source: https://developer.energy-hub.io/api-reference/user-vehicle-controller/delete-vehicle-for-user
delete /v1.0.0/users/{userId}/vehicles/{vehicleId}
Deletes the vehicle for the user.
# Refresh vehicle data for user
Source: https://developer.energy-hub.io/api-reference/user-vehicle-controller/refresh-vehicle-data-for-user
get /v1.0.0/users/{userId}/vehicles/{vehicleId}/refresh
Updates vehicle with newest data from vendor system for the user.
# Submit command for vehicle charging schedule
Source: https://developer.energy-hub.io/api-reference/user-vehicle-controller/submit-command-for-vehicle-charging-schedule
post /v1.0.0/users/{userId}/vehicles/{vehicleId}/commands/charging-schedule
This endpoint creates an asynchronously executed command request to schedule charging.
Charging Schedules are only supported for **BMW**, **MINI** and **Tesla**
vehicles.
# Submit command for vehicle to start charging
Source: https://developer.energy-hub.io/api-reference/user-vehicle-controller/submit-command-for-vehicle-to-start-charging
post /v1.0.0/users/{userId}/vehicles/{vehicleId}/commands/charging-start
This endpoint creates an asynchronously executed command request to start charging.
# Submit command for vehicle to stop charging
Source: https://developer.energy-hub.io/api-reference/user-vehicle-controller/submit-command-for-vehicle-to-stop-charging
post /v1.0.0/users/{userId}/vehicles/{vehicleId}/commands/charging-stop
This endpoint creates an asynchronously executed command request to stop charging.
# Vehicle commands
Source: https://developer.energy-hub.io/api-reference/user-vehicle-controller/vehicle-commands
get /v1.0.0/users/{userId}/vehicles/{vehicleId}/commands
Returns pending commands for vehicle
# Vehicle data for user
Source: https://developer.energy-hub.io/api-reference/user-vehicle-controller/vehicle-data-for-user
get /v1.0.0/users/{userId}/vehicles/{vehicleId}
Returns vehicle data of a single vehicle for the user.
# Vehicle image for user
Source: https://developer.energy-hub.io/api-reference/user-vehicle-controller/vehicle-image-for-user
get /v1.0.0/users/{userId}/vehicles/{vehicleId}/image.png
Returns the vehicle image as png file for the user.
# All vehicles
Source: https://developer.energy-hub.io/api-reference/vehicle-controller/all-vehicles
get /v1.0.0/vehicles
Returns a paginated and searchable list of all vehicles of the subscription.
# Delete vehicle
Source: https://developer.energy-hub.io/api-reference/vehicle-controller/delete-vehicle
delete /v1.0.0/vehicles/{vehicleId}
Deletes the vehicle.
# Refresh vehicle data
Source: https://developer.energy-hub.io/api-reference/vehicle-controller/refresh-vehicle-data
get /v1.0.0/vehicles/{vehicleId}/refresh
Updates vehicle with newest data from vendor system.
# Submit command for vehicle charging schedule
Source: https://developer.energy-hub.io/api-reference/vehicle-controller/submit-command-for-vehicle-charging-schedule
post /v1.0.0/vehicles/{vehicleId}/commands/charging-schedule
This endpoint creates an asynchronously executed command request to schedule charging.
Charging Schedules are only supported for **BMW**, **MINI** and **Tesla**
vehicles.
# Submit command for vehicle to start charging
Source: https://developer.energy-hub.io/api-reference/vehicle-controller/submit-command-for-vehicle-to-start-charging
post /v1.0.0/vehicles/{vehicleId}/commands/charging-start
This endpoint creates an asynchronously executed command request to start charging.
# Submit command for vehicle to stop charging
Source: https://developer.energy-hub.io/api-reference/vehicle-controller/submit-command-for-vehicle-to-stop-charging
post /v1.0.0/vehicles/{vehicleId}/commands/charging-stop
This endpoint creates an asynchronously executed command request to stop charging.
# Vehicle commands
Source: https://developer.energy-hub.io/api-reference/vehicle-controller/vehicle-commands
get /v1.0.0/vehicles/{vehicleId}/commands
Returns pending commands for vehicle
# Vehicle data
Source: https://developer.energy-hub.io/api-reference/vehicle-controller/vehicle-data
get /v1.0.0/vehicles/{vehicleId}
Returns vehicle data of a single vehicle.
# Vehicle image
Source: https://developer.energy-hub.io/api-reference/vehicle-controller/vehicle-image
get /v1.0.0/vehicles/{vehicleId}/image.png
Returns the vehicle image as png file.
# Link tariffs
Source: https://developer.energy-hub.io/api-reference/vendor-account-tariff-link-controller/link-tariffs-from-vendor-account
post /v1.0.0/link/users/{userId}/vendor-accounts/{vendorAccountId}/tariffs
Link list of tariffs from end user`s vendor account.
# List tariffs from vendor
Source: https://developer.energy-hub.io/api-reference/vendor-account-tariff-link-controller/returns-tariffs-for-vendor-account-directly-from-vendor-api
get /v1.0.0/link/users/{userId}/vendor-accounts/{vendorAccountId}/tariffs
Returns tariffs for vendor account directly from vendor API.
# Link vehicles
Source: https://developer.energy-hub.io/api-reference/vendor-account-vehicles-link-controller/link-vehicles
post /v1.0.0/link/users/{userId}/vendor-accounts/{vendorAccountId}/vehicles
Connects the provided list of vehicles from the vendor account to the Energy Hub Alliance.
# List vehicles from vendor
Source: https://developer.energy-hub.io/api-reference/vendor-account-vehicles-link-controller/list-vehicles-from-vendor
get /v1.0.0/link/users/{userId}/vendor-accounts/{vendorAccountId}/vehicles
Returns connected vehicles for the vendor account directly from vendor system.
# Device Lifecycle
Source: https://developer.energy-hub.io/documentation/connect/device-lifecycle
## Overview
This page describes the lifecycle states a device can be in after it has been linked to the Energy Hub, and which events or API behaviors are associated with state changes.
## States
### Connected
* The `isConnected` field in the general device data model indicates whether the vendor account is authenticated and device access is intact.
* If a vendor account becomes unauthenticated or access is otherwise lost, the device is disconnected.
* On a state change, the `CONNECT` or `DISCONNECT` event is emitted.
```mermaid theme={null}
flowchart TB
Start[Device gets connected]
Connected[Connected]
Disconnected[Disconnected]
Start --> Connected
ConnectMsg[CONNECT Event]
Start -.-> ConnectMsg
Connected -- Device Authentication Expires --> Disconnected
DisconnectMsg[DISCONNECT Event]
Disconnected -.-> DisconnectMsg
%% Emphasize event boxes (secondary color outline only)
classDef event fill:transparent,stroke:#00FF7F,stroke-width:2px;
%% Style state boxes with primary color outline
classDef state fill:transparent,stroke:#871FFF,stroke-width:2px;
class Connected,Disconnected state;
class ConnectMsg,DisconnectMsg event;
```
This state is not recoverable automatically; it requires end‑user or partner
intervention.
When a `DISCONNECT` event is received, the connected state **is not auto‑recoverable**. The device **has to be is reconnected by the end‑user** via the standard connect flow: prompt the user to restart the connect session for this device type and complete vendor authentication.
The Energy Hub cannot recover disconnected states by itself and does not delete devices automatically. To avoid billing of disconnected devices, devices must be reconnected or deleted by the partner.
### Online
* The `isOnline` field indicates whether the device is currently reachable for updating state parameters.
* A device can remain authenticated (connected) yet be temporarily unreachable due to connectivity issues, vendor throttling, or geofencing.
* Offline detection can take up to 24 hours for some devices.
* A device is considered online even if only a subset of parameters can be refreshed. If no parameters can be updated, `isOnline` becomes `false` within 24 hours.
* The `isOnline` state recovers automatically when reachability returns; no user or partner action is required.
* When `isOnline` changes, the change is communicated as part of the device "update" method (state update events/streams).
```mermaid theme={null}
flowchart TB
Online[Online]
NoOnline[No Online]
Online <-->|Device Reachable| NoOnline
UpdateMsg[UPDATE Event]
Online -.-> UpdateMsg
NoOnline -.-> UpdateMsg
%% Emphasize event box (secondary color outline only)
classDef event fill:transparent,stroke:#00FF7F,stroke-width:2px;
%% Style state boxes with primary color outline
classDef state fill:transparent,stroke:#871FFF,stroke-width:2px;
class Online,NoOnline state;
class UpdateMsg event;
```
### Deleted
* The Energy Hub does not delete devices autonomously.
* Device deletion is initiated by the partner.
* When a partner deletes a device, deletion is confirmed via the `DELETED` event.
```mermaid theme={null}
flowchart TB
Start[Partner deletes device]
Deleted[Deleted]
Start --> Deleted
DeleteMsg[DELETE Event]
Deleted -.-> DeleteMsg
%% Emphasize event box (secondary color outline only)
classDef event fill:transparent,stroke:#00FF7F,stroke-width:2px;
%% Style state boxes with primary color outline
classDef state fill:transparent,stroke:#871FFF,stroke-width:2px;
class Deleted state;
class DeleteMsg event;
```
# Introduction
Source: https://developer.energy-hub.io/documentation/connect/introduction
Connect offers the most transparent and customizable method to connect user energy devices and accounts.
Before initiating API requests and receiving streaming data from energy devices, the user must connect their vendor account to your application. The Energy Hub Alliance manages this without the need for an additional user interface, ensuring that the connection process is handled entirely through API endpoints. With this approach, it's up to you how things look in your end-user frontend, and your connect flow implementation remains fully customizable.
**The connect flow is divided into two steps: connect session and linking:**
As a first step, the user's vendor account needs to be connected with the
Energy Hub Alliance. Connecting the vendor account authenticates the user's
account with the Energy Hub Alliance through the official vendor third-party
flow. Once this step is completed, you can link energy devices from that
vendor account to the Energy Hub Alliance.
As a second step, the energy devices of the connected vendor account can now
be linked with the Energy Hub Alliance. This allows the user to choose
precisely which devices to connect from that vendor account.
# Connect and Link Sequence
Source: https://developer.energy-hub.io/documentation/connect/sequence
### Steps
To inform your user which energy brands or manufacturers are currently supported, the endpoint [All available vendors](/api-reference/connection-controller/all-available-vendors) helps you prepare the vendor selection screen. You can use this list as the basis for offering users a choice of which vendors to connect to.
The connect session is initiated by redirecting your user to the URL provided by calling, for example, [Connect session for vehicle](/api-reference/connection-controller/connect-url-for-a-vehicle-vendor) (the specific endpoint depends on the device type you want to connect). The user will be redirected to the vendor's official identity provider (IDP) and will connect their vendor account to the Energy Hub Alliance.
When the connection is successful, the redirect will include the `vendorAccountId` as a parameter in the redirect URL. This `vendorAccountId` is required for the following steps to link the devices associated with the vendor account.
The connect session only connects the user's vendor account. To link the devices from that vendor account, continue with the next two steps.
A connected vendor account can include several energy devices. To retrieve a list of devices connected to the vendor account, use, for example, [List vehicles from vendor](/api-reference/vendor-account-vehicles-link-controller/list-vehicles-from-vendor) (the specific endpoint depends on the device type you want to connect).
As a final step, once the user or application has decided which devices should be added, [Link vehicles](/api-reference/vendor-account-vehicles-link-controller/link-vehicles) links the selected devices to the platform. All set! The items are now linked to the Energy Hub Alliance and can be accessed through the API. Data streaming should also begin for the linked devices.
### Sequence Diagram (simplified)
```mermaid theme={null}
sequenceDiagram
autonumber
actor User
participant A as Application
participant EHA as Energy Hub Alliance
participant V as Vendor IDP
A->>EHA: Get available vendors
User->>A: Pick vendor to connect
A->>EHA: Create connect session for vendor
User->>V: Direct to connect URL
Note right of V: User login and consent
EHA->>A: Redirect with vendor account ID
A->>EHA: Get energy devices from vendor account
User->>A: Selects energy devices to link
A->>EHA: Link devices to Energy Hub Alliance
```
# User Consent Screen
Source: https://developer.energy-hub.io/documentation/connect/user-consent-screen
Learn about the User Consent Screen component that ensures GDPR compliance in the connect flow.
The User Consent Screen is a crucial component of the connect flow that ensures compliance with GDPR (General Data Protection Regulation) requirements. This screen appears as the first screen of the connect process to obtain explicit user consent for data processing and sharing.
The user-consent screen will be shown in the design configured in the partner
portal.
## Why this screen is needed
The User Consent Screen is required for several important reasons:
* **GDPR Compliance**: The European Union's General Data Protection Regulation mandates that users must give explicit consent before their personal data can be processed
* **Data Transparency**: Users need to understand what data will be collected, how it will be used, and with whom it will be shared
* **Legal Protection**: Both the platform and users are protected by having clear consent documentation
## Custom GDPR consent in your own application
In order to stay fully flexible in the connect flow, it is possible for your app to take over the responsibility of informing the end-user about the GDPR relevant information, before redirecting the user to the Energy Hub Alliance.
To inform the Energy Hub about using your own GDPR screen, you need to explicitly set the `isUserGdprInformationProvided` parameter to `TRUE` in the [Connect URL Request](/api-reference/connection-controller/connect-url-for-a-vehicle-vendor). This disables the Energy Hub Alliance consent screen in the connect flow.
### Best Practices
When you create your own consent screen to inform about the Energy Hub Alliance, we recommend:
* Present consent options before any data collection begins
* Make the consent process mandatory - users cannot proceed without providing consent
* Provide easy access to privacy policies and terms of service
* Allow users to review and modify their consent preferences at any time
# Introduction
Source: https://developer.energy-hub.io/documentation/control/introduction
The Energy Hub provides the ability to send commands to various types of devices. A consistent mechanism is used across all vendors and device types for sending commands and checking their status.
The availability of specific commands for vendors depends on the vendor and the configurations set by the end-user. You can find an overview of the control capability on the [capability](/documentation/capabilities) page.
In summary, commands are issued through REST API endpoints, such as [Submit Command for Vehicle](api-reference/vehicle-controller/submit-command-for-vehicle). The Energy Hub manages the execution status of the commands. Once the status of a command changes, the application is notified via the streaming service.
# Mechanism
Source: https://developer.energy-hub.io/documentation/control/mechanism
When the command endpoints, such as [Submit Command for Vehicle](api-reference/vehicle-controller/submit-command-for-vehicle) is called, the sending application will be informed that the command is in a PENDING state, indicating that it is being processed for submission to the vendor and execution by the target device. Additionally, the Energy Hub will send a notification at this stage.
The command submission to the vendor system is handled asynchronously, meaning the caller of the command endpoint does not wait for the command to be submitted to the vendor system. The Energy Hub will provide updates on the command state change via a notification message sent through the appropriate Streaming topic.
## States of commands
* PENDING: Represents that command is registered and maybe submitted to Vendor system for execution before target device has executed it.
* FAILED: Represents unsuccessful execution of command. Command did not reach Vendor system or it has been rejected by it.
* EXECUTED: Represents successful execution of command.
**Command state change**
```mermaid theme={null}
stateDiagram
[*] --> PENDING
PENDING --> FAILED
FAILED --> [*]
PENDING --> EXECUTED
EXECUTED --> [*]
```
Not all devices have the same command capabilities. For example, vehicles may support remote start charging, while this is not possible for HVAC devices.
When the submit command endpoint is called in one of the service APIs provided by the Energy Hub, the first check performed is to verify the existence of the target device. If the device does not exist, an appropriate error message is returned.
## Data model
After command is created, it is provided as a command object in the REST API with the following data model:
```json theme={null}
{
"id": "f6e5bbbc-bfd1-4856-a4bf-9b0d2a1adcce",
"userId": "user123",
"type": "CHARGING_START",
"state": "PENDING",
"failedReason": null,
"createdAt": "2024-09-04T14:08:11.995Z",
"lastUpdated": null,
"deviceId": "e110ed44-69e6-4fbd-bcc9-95901e17ad62"
}
```
# Introduction
Source: https://developer.energy-hub.io/documentation/introduction
Welcome to the Energy Hub Alliance Developer Portal!
The Energy Hub Alliance documentation section explains everything you need to get started and how the connect flow and data streaming work. The API reference documents all endpoints needed to interact with the Energy Hub Alliance.
# Quickstart
Source: https://developer.energy-hub.io/documentation/quickstart
The Energy Hub Alliance lets you connect all kinds of energy vendors to your application. Follow these first steps, to set up your application environment.
### Setup your subscription and clients
Before you can get started and use the Energy Hub Alliance, you need to setup clients for the API and streaming clients.
Subscriptions, API keys and streaming clients can be created once you have
access to the [Partner Portal](https://partner.energy-hub.io). To apply for
access to the partner portal contact us at
[info@energy-hub-alliance.com](mailto:info@energy-hub-alliance.com).
To add a new subscription, you need to provide a application name and a
redirect URL. The redirect URL is needed for the connect flow, to direct the
user back to your application.
To authenticate to the Energy Hub API, you can create one or more API-keys.
Make sure to store these API-keys safely, since they will be used to
authenticate your application. The API keys are connected to your
subscription.
To recieve streaming data, create a streaming client in the partner portal
and configure your Kafka Broker to recieve messages.
### Start developing
The Energy Hub Alliance provides a reference implementation, to help to you
understand the general concepts like streaming and the implementation of the
connect flow. Check out our [Github](https://github.com/energy-hub-alliance).
Check out the API reference to get used to concepts and understand the
endpoints.
Set up the connect flow in you application to onboard first energy devices.
Set up and configure a streaming client.
# Simulated Connect
Source: https://developer.energy-hub.io/documentation/sandbox/simulated-connect
Connect simulated vendor accounts and link virtual devices in the Sandbox environment without contacting real vendor identity providers.
The Sandbox environment allows you to go through the full connect and link flow without contacting a real vendor identity provider (IDP). This lets you develop and test your integration end-to-end using virtual devices.
The simulated connect flow is only active on subscriptions with **Sandbox**
mode. On Live subscriptions, the standard connect flow with real vendor IDPs
is used.
## How It Works
The Sandbox connect flow behaves exactly like the production flow in terms of workflows, endpoint responses, and data model. The only difference is that no real vendor IDP is contacted. The Energy Hub Alliance simulates the vendor side entirely.
**The simulated connect flow follows the same two steps as production: connect session and linking:**
When you create a connect session in Sandbox mode, the user is redirected back
to your redirect URI with a simulated `vendorAccountId` -- no real vendor
authentication takes place. If the vendor has a custom connect screen, the
screen is still shown but all user input is ignored. If the vendor has no
custom connect screen, the redirect happens immediately.
During the link flow, a standard list of virtual devices is presented for the
vendor. You select which devices to link, just like in production. Once
linking is complete, the simulated devices are created and available through
the API.
## Connect Flow Details
Initiate the connect session using the same API endpoints as in production,
for example [Connect session for vehicle](/api-reference/connection-controller/connect-url-for-a-vehicle-vendor).
Redirect the user to the returned connect URL.
Instead of authenticating with a real vendor IDP, the Sandbox environment
handles the redirect automatically:
* **Vendor with custom connect screen:** The connect screen is displayed as
usual, but user input is not validated against a real vendor. The user is
then redirected back to your `redirectUri` with a simulated
`vendorAccountId`.
* **Vendor without custom connect screen:** The user is immediately
redirected back to your `redirectUri` with a simulated `vendorAccountId`.
A simulated vendor account is created on redirect.
Use the same list endpoints as in production, for example
[List vehicles from vendor](/api-reference/vendor-account-vehicles-link-controller/list-vehicles-from-vendor),
to retrieve the available virtual devices. A standard set of one device per
category is returned for each vendor.
Link the selected virtual devices using the same endpoints as in production,
for example
[Link vehicles](/api-reference/vendor-account-vehicles-link-controller/link-vehicles).
Once linking is complete, the simulated devices are created and fully
accessible through the API, including data streaming.
Since the Sandbox environment mirrors the production data model and workflows,
you can reuse the same integration code for both environments. Switch between
them simply by using the credentials from your Sandbox or Live subscription.
# Simulated Devices
Source: https://developer.energy-hub.io/documentation/sandbox/simulated-devices
Edit virtual device states in the Partner Portal to test your integration with realistic data.
After linking virtual devices through the [Simulated Connect](/documentation/sandbox/simulated-connect) flow, you can manually control their state directly from the Partner Portal. This allows you to simulate real-world device behavior in the partner portal and verify that your application handles data changes correctly.
## Editing Device State
In the Partner Portal, navigate to a Sandbox subscription's device connections. Clicking on a linked virtual device opens an editing dialog where you can modify the device's data model.
The dialog displays the full data model of the device, organized into sections such as **General Info**, **Charge State**, and **Climate State**. Most fields can be freely edited to simulate any device scenario you need.
### Read-Only Fields
Some fields are managed by the system and cannot be edited manually:
| Field | Reason |
| ---------------- | -------------------------------------------------------- |
| **Last Updated** | Automatically set by the system when changes are applied |
| **Vendor** | Static value determined during the connect flow |
### Editable Fields
All other fields in the data model can be modified. For a vehicle, this includes fields such as vehicle name, model, VIN, battery capacity, charging state, state of charge, charge rate, temperatures, climate settings, and more. The complete data model is documented in the [Vehicle Data](/api-reference/vehicle-controller/vehicle-data) API reference.
## Applying Changes
Once you have adjusted the desired fields, click **Apply Changes**. This triggers the following:
1. The virtual device state is updated immediately with the new values.
2. A device **update** event is sent through the [streaming service](/documentation/streaming/events) right away, just as it would happen when a real device reports new data.
The streaming update message follows the same format and topic naming as
production events. Your application receives the update on the ` {subscriptionId}.{deviceType}.update` topic, allowing you to verify your
streaming integration end-to-end.
Use this feature to test edge cases in your application, for example by
setting a very low state of charge, toggling climate controls, or changing the
charging state -- all without needing a physical device.
# Sandbox Subscriptions
Source: https://developer.energy-hub.io/documentation/sandbox/subscriptions
Create a Sandbox environment to test integrations without real devices.
The Sandbox is currently only available for vehicles. Support for all other
device types will be added soon.
When adding a new subscription in the Partner Portal, you can choose between two subscription types: **Live** and **Sandbox**. This allows you to set up a dedicated test environment before going into production.
## Subscription Types
A safe test environment for experimenting with integrations using virtual
devices. Use this to test your integration.
Environment where you connect to actual devices. Use this mode for
production or testing with real devices.
## Creating a Sandbox Subscription
In the Partner Portal, go to the subscription management section and click
on **Add Subscription**.
Choose between **Live** and **Sandbox** as the subscription type.
Select **Sandbox** if you want to test your integration in a safe
environment with virtual devices. Select **Live** when you are ready to
connect to real devices.
Fill in the remaining subscription details and confirm. Your new Sandbox
subscription will be ready to use immediately.
You can have both Sandbox and Live subscriptions active at the same time. This
lets you develop and test new features in the Sandbox while your production
integration continues to run on the Live subscription.
# Event Types
Source: https://developer.energy-hub.io/documentation/streaming/events
## General information
There are events for energy devices that trigger streaming messages. Receiving event-based data is useful for handling asynchronous events, such as commands, and ensuring that your system stays up to date with the latest device information. The Energy Hub Alliance will ensure automatically that vendor data is always up to date.
We recommend using streaming instead of API polling to avoid delays and reduce unnecessary traffic.
In case you feel that data of a device might be outdated, a data update can be
requested manually. This function is triggered by calling e.g. [Refresh
vehicle data](/api-reference/vehicle-controller/refresh-vehicle-data). In
addition to the response of the API-request, this will also trigger a
streaming message, if the device can be reached. The refresh endpoints should
be used with caution, as it might trigger too many requests to the vendor API
when used too excessively.
## Message format
Kafka messages send to your Kafka Broker have the following format:
`{subscriptionId}.{deviceType}.{eventType}`
The **subscriptionId** is the ID of your subscription created in the partner portal. The **deviceType** is the type of the connected device or object, for example a vehicle, tariff, HVAC or home energy device. The **eventType** is the action related to the message and described in more details below.
## Supported event types
There are three main events types supported by the streaming service.
Notifies if a new device has been connected to the Energy Hub Alliance.
Notifies when a device becomes disconnected due to lost authentication or
revoked access.
Sends the newest data of a device, when at least one data model property has
changed. Use this event to recieve the latest device data.
Notifies if a new device has been deleted from the Energy Hub by the
end-user or the partner.
Notifies if a device has not been reachable for some time from and went
offline.
Notifies about the creation and status of a command.
# Examples
Source: https://developer.energy-hub.io/documentation/streaming/examples
## Event Examples
All message always send the full data model object of the related device type of the message. In case of the `connect` or `delete` message, the last know state of the device will be send.
Below you find examples for each device type. Generally, each device type mostly has the same message types: `connect`, `update`, `delete`, `offline`, and `disconnect` notifications. For devices which support commands, notifications about commands are also sent through the `command` message type.
### Vehicle Streaming Message Examples
Vehicles can send the following message types:
* `{subscriptionId}.vehicle.connect`
* `{subscriptionId}.vehicle.update`
* `{subscriptionId}.vehicle.delete`
* `{subscriptionId}.vehicle.offline`
* `{subscriptionId}.vehicle.command`
* `{subscriptionId}.vehicle.disconnect`
```json Vehicle Connect theme={null}
{
"lastUpdated": "2023-11-07T05:31:56Z",
"chargeState": {
"stateOfCharge": 72.25,
"chargingTimeRemaining": 6,
"chargeLimitMax": 80.25,
"remoteChargingAllowed": true,
"estimatedRange": 106,
"chargingState": "CHARGING",
"chargeRate": 6.512,
"lastUpdated": "2023-11-07T05:31:56Z",
"chargeLimitMin": 20.25,
"chargeCurrentMax": 12,
"scheduledDepartureTime": "2023-11-26T05:05:00Z",
"isPlugged": true,
"scheduledChargingStartTime": "2023-11-26T05:00:00Z"
},
"odometer": {
"lastUpdated": "2023-11-07T05:31:56Z",
"odometer": 12228
},
"isOnline": true,
"location": {
"lastUpdated": "2023-11-07T05:31:56Z",
"latitude": 50.770774,
"longitude": -126.104965
},
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"climateState": {
"lastUpdated": "2023-11-07T05:31:56Z",
"isClimateOn": true,
"isBatteryHeaterOn": true,
"temperatureCurrent": 18.1,
"temperatureTarget": 20.1
},
"userId": "896f9d5a-b618-48a2-98ae-957059bf1bc9",
"staticData": {
"lastUpdated": "2023-11-07T05:31:56Z",
"vendor": "TESLA",
"name": "My Tesla",
"engineType": "BEV",
"vin": "1XKAD29X0KS502460",
"model": "Model 3",
"batteryCapacity": 60.12,
"vehicleVariant": "Base"
}
}
```
```json Vehicle Update theme={null}
{
"lastUpdated": "2023-11-07T05:31:56Z",
"chargeState": {
"stateOfCharge": 72.25,
"chargingTimeRemaining": 6,
"chargeLimitMax": 80.25,
"remoteChargingAllowed": true,
"estimatedRange": 106,
"chargingState": "CHARGING",
"chargeRate": 6.512,
"lastUpdated": "2023-11-07T05:31:56Z",
"chargeLimitMin": 20.25,
"chargeCurrentMax": 12,
"scheduledDepartureTime": "2023-11-26T05:05:00Z",
"isPlugged": true,
"scheduledChargingStartTime": "2023-11-26T05:00:00Z"
},
"odometer": {
"lastUpdated": "2023-11-07T05:31:56Z",
"odometer": 12228
},
"isOnline": true,
"location": {
"lastUpdated": "2023-11-07T05:31:56Z",
"latitude": 50.770774,
"longitude": -126.104965
},
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"climateState": {
"lastUpdated": "2023-11-07T05:31:56Z",
"isClimateOn": true,
"isBatteryHeaterOn": true,
"temperatureCurrent": 18.1,
"temperatureTarget": 20.1
},
"userId": "896f9d5a-b618-48a2-98ae-957059bf1bc9",
"staticData": {
"lastUpdated": "2023-11-07T05:31:56Z",
"vendor": "TESLA",
"name": "My Tesla",
"engineType": "BEV",
"vin": "1XKAD29X0KS502460",
"model": "Model 3",
"batteryCapacity": 60.12,
"vehicleVariant": "Base"
}
}
```
```json Vehicle Delete theme={null}
{
"lastUpdated": "2023-11-07T05:31:56Z",
"chargeState": {
"stateOfCharge": 72.25,
"chargingTimeRemaining": 6,
"chargeLimitMax": 80.25,
"remoteChargingAllowed": true,
"estimatedRange": 106,
"chargingState": "CHARGING",
"chargeRate": 6.512,
"lastUpdated": "2023-11-07T05:31:56Z",
"chargeLimitMin": 20.25,
"chargeCurrentMax": 12,
"scheduledDepartureTime": "2023-11-26T05:05:00Z",
"isPlugged": true,
"scheduledChargingStartTime": "2023-11-26T05:00:00Z"
},
"odometer": {
"lastUpdated": "2023-11-07T05:31:56Z",
"odometer": 12228
},
"isOnline": true,
"location": {
"lastUpdated": "2023-11-07T05:31:56Z",
"latitude": 50.770774,
"longitude": -126.104965
},
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"climateState": {
"lastUpdated": "2023-11-07T05:31:56Z",
"isClimateOn": true,
"isBatteryHeaterOn": true,
"temperatureCurrent": 18.1,
"temperatureTarget": 20.1
},
"userId": "896f9d5a-b618-48a2-98ae-957059bf1bc9",
"staticData": {
"lastUpdated": "2023-11-07T05:31:56Z",
"vendor": "TESLA",
"name": "My Tesla",
"engineType": "BEV",
"vin": "1XKAD29X0KS502460",
"model": "Model 3",
"batteryCapacity": 60.12,
"vehicleVariant": "Base"
}
}
```
```json Vehicle Offline theme={null}
{
"lastUpdated": "2023-11-07T05:31:56Z",
"chargeState": {
"stateOfCharge": 72.25,
"chargingTimeRemaining": 6,
"chargeLimitMax": 80.25,
"remoteChargingAllowed": true,
"estimatedRange": 106,
"chargingState": "CHARGING",
"chargeRate": 6.512,
"lastUpdated": "2023-11-07T05:31:56Z",
"chargeLimitMin": 20.25,
"chargeCurrentMax": 12,
"scheduledDepartureTime": "2023-11-26T05:05:00Z",
"isPlugged": true,
"scheduledChargingStartTime": "2023-11-26T05:00:00Z"
},
"odometer": {
"lastUpdated": "2023-11-07T05:31:56Z",
"odometer": 12228
},
"isOnline": False,
"location": {
"lastUpdated": "2023-11-07T05:31:56Z",
"latitude": 50.770774,
"longitude": -126.104965
},
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"climateState": {
"lastUpdated": "2023-11-07T05:31:56Z",
"isClimateOn": true,
"isBatteryHeaterOn": true,
"temperatureCurrent": 18.1,
"temperatureTarget": 20.1
},
"userId": "896f9d5a-b618-48a2-98ae-957059bf1bc9",
"staticData": {
"lastUpdated": "2023-11-07T05:31:56Z",
"vendor": "TESLA",
"name": "My Tesla",
"engineType": "BEV",
"vin": "1XKAD29X0KS502460",
"model": "Model 3",
"batteryCapacity": 60.12,
"vehicleVariant": "Base"
}
}
```
```json Vehicle Command theme={null}
{
"id": "c1eb00d9-4106-45ed-ab07-9d6452a18a51",
"userId": "681db72f-4b75-46d9-8d68-58be479faf85",
"deviceId": "788ebcbc-2d9b-4667-8498-9628601f1a95",
"type": "CHARGING_START",
"state": "EXECUTED",
"failedReason": null,
"createdAt": "2024-12-10T13:31:45.528Z",
"lastUpdated": "2024-12-10T13:31:46.885Z"
}
```
```json Vehicle Disconnect theme={null}
{
"deviceId": "0393521a-baf2-47f2-8071-6c64cfecf0a8",
"vendorAccountId": "e454420b-6705-42e3-a110-f40b0ba52629",
"userId": "a5ac2de6-fd9d-4df2-b01c-1ce77ee03c7b",
"vendor": "TESLA",
"reason": "AUTHENTICATION_EXPIRED",
"resolution": "RECONNECT_DEVICE"
}
```
### Tariff Streaming Message Examples
Tariffs can send the following message types:
* `{subscriptionId}.tariff.connect`
* `{subscriptionId}.tariff.update`
* `{subscriptionId}.tariff.price.update`
* `{subscriptionId}.tariff.delete`
* `{subscriptionId}.tariff.disconnect`
```json Tariff Connect theme={null}
{
"id": "b063cd05-a48f-4513-9abe-060a13546bdb",
"userId": "5f48946a-4203-495b-9c8b-7c31ae84009a",
"locationId": null,
"isOnline": true,
"staticData": {
"vendor": "OSTROM",
"name": "Ostrom Feldstraße 22",
"currency": "EUR",
"countryCode": "DE",
"lastUpdated": "2024-12-26T13:41:28.075Z"
}
}
```
```json Tariff Update theme={null}
{
"id": "b063cd05-a48f-4513-9abe-060a13546bdb",
"userId": "5f48946a-4203-495b-9c8b-7c31ae84009a",
"locationId": null,
"isOnline": true,
"staticData": {
"vendor": "OSTROM",
"name": "Ostrom Feldstraße 22",
"currency": "EUR",
"countryCode": "DE",
"lastUpdated": "2024-12-26T13:41:28.075Z"
}
}
```
```json Tariff Price Update theme={null}
{
"id": "d15b07cd-7652-45e8-8a4f-5d760b59ee00",
"userId": "d3f6a25e-8a77-4833-bbf7-735a457cdecf",
"locationId": null,
"prices": [
{
"totalPrice": 0.1864,
"energyPrice": 0.0348,
"taxAndLevies": 0.1516,
"startDate": "2024-12-22T23:00:00.000Z"
},
{
"totalPrice": 0.1756,
"energyPrice": 0.024,
"taxAndLevies": 0.1516,
"startDate": "2024-12-23T00:00:00.000Z"
},
{
"totalPrice": 0.1687,
"energyPrice": 0.0171,
"taxAndLevies": 0.1516,
"startDate": "2024-12-23T01:00:00.000Z"
},
{
"totalPrice": 0.1625,
"energyPrice": 0.0109,
"taxAndLevies": 0.1516,
"startDate": "2024-12-23T02:00:00.000Z"
},
{
"totalPrice": 0.1633,
"energyPrice": 0.0117,
"taxAndLevies": 0.1516,
"startDate": "2024-12-23T03:00:00.000Z"
},
{
"totalPrice": 0.1693,
"energyPrice": 0.0177,
"taxAndLevies": 0.1516,
"startDate": "2024-12-23T04:00:00.000Z"
},
{
"totalPrice": 0.1723,
"energyPrice": 0.0207,
"taxAndLevies": 0.1516,
"startDate": "2024-12-23T05:00:00.000Z"
},
{
"totalPrice": 0.2135,
"energyPrice": 0.0619,
"taxAndLevies": 0.1516,
"startDate": "2024-12-23T06:00:00.000Z"
},
{
"totalPrice": 0.2223,
"energyPrice": 0.0707,
"taxAndLevies": 0.1516,
"startDate": "2024-12-23T07:00:00.000Z"
},
{
"totalPrice": 0.2226,
"energyPrice": 0.071,
"taxAndLevies": 0.1516,
"startDate": "2024-12-23T08:00:00.000Z"
},
{
"totalPrice": 0.2144,
"energyPrice": 0.0628,
"taxAndLevies": 0.1516,
"startDate": "2024-12-23T09:00:00.000Z"
},
{
"totalPrice": 0.2135,
"energyPrice": 0.0619,
"taxAndLevies": 0.1516,
"startDate": "2024-12-23T10:00:00.000Z"
},
{
"totalPrice": 0.2161,
"energyPrice": 0.0645,
"taxAndLevies": 0.1516,
"startDate": "2024-12-23T11:00:00.000Z"
},
{
"totalPrice": 0.2169,
"energyPrice": 0.0653,
"taxAndLevies": 0.1516,
"startDate": "2024-12-23T12:00:00.000Z"
},
{
"totalPrice": 0.2249,
"energyPrice": 0.0733,
"taxAndLevies": 0.1516,
"startDate": "2024-12-23T13:00:00.000Z"
},
{
"totalPrice": 0.2393,
"energyPrice": 0.0877,
"taxAndLevies": 0.1516,
"startDate": "2024-12-23T14:00:00.000Z"
},
{
"totalPrice": 0.2499,
"energyPrice": 0.0983,
"taxAndLevies": 0.1516,
"startDate": "2024-12-23T15:00:00.000Z"
},
{
"totalPrice": 0.2686,
"energyPrice": 0.117,
"taxAndLevies": 0.1516,
"startDate": "2024-12-23T16:00:00.000Z"
},
{
"totalPrice": 0.2727,
"energyPrice": 0.1211,
"taxAndLevies": 0.1516,
"startDate": "2024-12-23T17:00:00.000Z"
},
{
"totalPrice": 0.2676,
"energyPrice": 0.116,
"taxAndLevies": 0.1516,
"startDate": "2024-12-23T18:00:00.000Z"
},
{
"totalPrice": 0.2618,
"energyPrice": 0.1102,
"taxAndLevies": 0.1516,
"startDate": "2024-12-23T19:00:00.000Z"
},
{
"totalPrice": 0.2805,
"energyPrice": 0.1289,
"taxAndLevies": 0.1516,
"startDate": "2024-12-23T20:00:00.000Z"
},
{
"totalPrice": 0.2776,
"energyPrice": 0.126,
"taxAndLevies": 0.1516,
"startDate": "2024-12-23T21:00:00.000Z"
},
{
"totalPrice": 0.2671,
"energyPrice": 0.1155,
"taxAndLevies": 0.1516,
"startDate": "2024-12-23T22:00:00.000Z"
},
{
"totalPrice": 0.254,
"energyPrice": 0.1024,
"taxAndLevies": 0.1516,
"startDate": "2024-12-23T23:00:00.000Z"
},
{
"totalPrice": 0.2502,
"energyPrice": 0.0986,
"taxAndLevies": 0.1516,
"startDate": "2024-12-24T00:00:00.000Z"
},
{
"totalPrice": 0.2491,
"energyPrice": 0.0975,
"taxAndLevies": 0.1516,
"startDate": "2024-12-24T01:00:00.000Z"
},
{
"totalPrice": 0.2445,
"energyPrice": 0.0929,
"taxAndLevies": 0.1516,
"startDate": "2024-12-24T02:00:00.000Z"
},
{
"totalPrice": 0.2454,
"energyPrice": 0.0938,
"taxAndLevies": 0.1516,
"startDate": "2024-12-24T03:00:00.000Z"
},
{
"totalPrice": 0.2476,
"energyPrice": 0.096,
"taxAndLevies": 0.1516,
"startDate": "2024-12-24T04:00:00.000Z"
},
{
"totalPrice": 0.2529,
"energyPrice": 0.1013,
"taxAndLevies": 0.1516,
"startDate": "2024-12-24T05:00:00.000Z"
},
{
"totalPrice": 0.2716,
"energyPrice": 0.12,
"taxAndLevies": 0.1516,
"startDate": "2024-12-24T06:00:00.000Z"
},
{
"totalPrice": 0.2886,
"energyPrice": 0.137,
"taxAndLevies": 0.1516,
"startDate": "2024-12-24T07:00:00.000Z"
},
{
"totalPrice": 0.2956,
"energyPrice": 0.144,
"taxAndLevies": 0.1516,
"startDate": "2024-12-24T08:00:00.000Z"
},
{
"totalPrice": 0.2944,
"energyPrice": 0.1428,
"taxAndLevies": 0.1516,
"startDate": "2024-12-24T09:00:00.000Z"
},
{
"totalPrice": 0.2923,
"energyPrice": 0.1407,
"taxAndLevies": 0.1516,
"startDate": "2024-12-24T10:00:00.000Z"
},
{
"totalPrice": 0.2915,
"energyPrice": 0.1399,
"taxAndLevies": 0.1516,
"startDate": "2024-12-24T11:00:00.000Z"
},
{
"totalPrice": 0.289,
"energyPrice": 0.1374,
"taxAndLevies": 0.1516,
"startDate": "2024-12-24T12:00:00.000Z"
},
{
"totalPrice": 0.292,
"energyPrice": 0.1404,
"taxAndLevies": 0.1516,
"startDate": "2024-12-24T13:00:00.000Z"
},
{
"totalPrice": 0.2939,
"energyPrice": 0.1423,
"taxAndLevies": 0.1516,
"startDate": "2024-12-24T14:00:00.000Z"
},
{
"totalPrice": 0.2947,
"energyPrice": 0.1431,
"taxAndLevies": 0.1516,
"startDate": "2024-12-24T15:00:00.000Z"
},
{
"totalPrice": 0.2921,
"energyPrice": 0.1405,
"taxAndLevies": 0.1516,
"startDate": "2024-12-24T16:00:00.000Z"
},
{
"totalPrice": 0.2837,
"energyPrice": 0.1321,
"taxAndLevies": 0.1516,
"startDate": "2024-12-24T17:00:00.000Z"
},
{
"totalPrice": 0.2774,
"energyPrice": 0.1258,
"taxAndLevies": 0.1516,
"startDate": "2024-12-24T18:00:00.000Z"
},
{
"totalPrice": 0.2737,
"energyPrice": 0.1221,
"taxAndLevies": 0.1516,
"startDate": "2024-12-24T19:00:00.000Z"
},
{
"totalPrice": 0.2643,
"energyPrice": 0.1127,
"taxAndLevies": 0.1516,
"startDate": "2024-12-24T20:00:00.000Z"
},
{
"totalPrice": 0.2695,
"energyPrice": 0.1179,
"taxAndLevies": 0.1516,
"startDate": "2024-12-24T21:00:00.000Z"
},
{
"totalPrice": 0.2587,
"energyPrice": 0.1071,
"taxAndLevies": 0.1516,
"startDate": "2024-12-24T22:00:00.000Z"
}
]
}
```
```json Tariff Delete theme={null}
{
"id": "b063cd05-a48f-4513-9abe-060a13546bdb",
"userId": "5f48946a-4203-495b-9c8b-7c31ae84009a",
"locationId": null,
"isOnline": true,
"staticData": {
"vendor": "OSTROM",
"name": "Ostrom Feldstraße 22",
"currency": "EUR",
"countryCode": "DE",
"lastUpdated": "2024-12-26T13:41:28.075Z"
}
}
```
```json Tariff Disconnect theme={null}
{
"deviceId": "0393521a-baf2-47f2-8071-6c64cfecf0a8",
"vendorAccountId": "e454420b-6705-42e3-a110-f40b0ba52629",
"userId": "a5ac2de6-fd9d-4df2-b01c-1ce77ee03c7b",
"vendor": "TIBBER",
"reason": "AUTHENTICATION_EXPIRED",
"resolution": "RECONNECT_DEVICE"
}
```
### HVAC Streaming Message Examples
HVACs can send the following message types:
* `{subscriptionId}.hvac.connect`
* `{subscriptionId}.hvac.update`
* `{subscriptionId}.hvac.schedules.update`
* `{subscriptionId}.hvac.delete`
* `{subscriptionId}.hvac.offline`
* `{subscriptionId}.hvac.command`
```json HVAC Connect theme={null}
{
"id": "6eb5497d-c6bb-4290-84ef-4409fe9501f1",
"userId": "896f9d5a-b618-48a2-98ae-957059bf1bc9",
"locationId": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
"isOnline": true,
"staticData": {
"type": "AC",
"room": "Living room",
"vendor": "VIESSMANN",
"model": "Vitotronic 200",
"name": "Viessmann Vitotronic 200",
"capableModes": ["HEAT"],
"lastUpdated": "2025-01-02T10:24:02.447Z"
},
"climateState": {
"isActive": null,
"mode": null,
"temperatureCurrent": null,
"temperatureOutside": null,
"temperatureTargets": [],
"lastUpdated": null
},
"powerState": {
"powerConsumption": null,
"lastUpdated": null
},
"lastUpdated": "2025-01-02T10:24:02.447Z"
}
```
```json HVAC Update theme={null}
{
"id": "6eb5497d-c6bb-4290-84ef-4409fe9501f1",
"userId": "896f9d5a-b618-48a2-98ae-957059bf1bc9",
"locationId": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
"isOnline": true,
"staticData": {
"type": "AC",
"room": "Living room",
"vendor": "VIESSMANN",
"model": "Vitotronic 200",
"name": "Viessmann Vitotronic 200",
"capableModes": ["HEAT"],
"lastUpdated": "2025-01-02T10:24:02.447Z"
},
"climateState": {
"isActive": true,
"mode": "HEAT",
"temperatureCurrent": 20.3,
"temperatureOutside": 12,
"temperatureTargets": [
{
"mode": "HEAT",
"temperature": 18
}
],
"lastUpdated": "2025-01-02T10:24:02.447Z"
},
"powerState": {
"powerConsumption": 0,
"lastUpdated": "2025-01-02T10:24:02.447Z"
},
"lastUpdated": "2025-01-02T10:24:02.447Z"
}
```
```json HVAC Schedules Update theme={null}
{
"id": "0fa47346-0038-4b76-b32a-5bfbd4868a25",
"userId": "896f9d5a-b618-48a2-98ae-957059bf1bc9",
"timeZone": "Europe/Berlin",
"schedules": [
{
"start": {
"day": "MONDAY",
"time": "04:30"
},
"end": {
"day": "MONDAY",
"time": "06:30"
},
"mode": "AUTO",
"temperature": 20
},
{
"start": {
"day": "MONDAY",
"time": "14:00"
},
"end": {
"day": "MONDAY",
"time": "16:00"
},
"mode": "AUTO",
"temperature": 21
},
{
"start": {
"day": "MONDAY",
"time": "16:00"
},
"end": {
"day": "MONDAY",
"time": "19:00"
},
"mode": "AUTO",
"temperature": 19
},
{
"start": {
"day": "MONDAY",
"time": "19:00"
},
"end": {
"day": "MONDAY",
"time": "19:30"
},
"mode": "AUTO",
"temperature": 20
},
{
"start": {
"day": "TUESDAY",
"time": "04:30"
},
"end": {
"day": "TUESDAY",
"time": "06:30"
},
"mode": "AUTO",
"temperature": 20
},
{
"start": {
"day": "TUESDAY",
"time": "14:00"
},
"end": {
"day": "TUESDAY",
"time": "16:00"
},
"mode": "AUTO",
"temperature": 21
},
{
"start": {
"day": "TUESDAY",
"time": "16:00"
},
"end": {
"day": "TUESDAY",
"time": "19:00"
},
"mode": "AUTO",
"temperature": 19
},
{
"start": {
"day": "TUESDAY",
"time": "19:00"
},
"end": {
"day": "TUESDAY",
"time": "19:30"
},
"mode": "AUTO",
"temperature": 20
},
{
"start": {
"day": "WEDNESDAY",
"time": "04:30"
},
"end": {
"day": "WEDNESDAY",
"time": "06:30"
},
"mode": "AUTO",
"temperature": 20
},
{
"start": {
"day": "WEDNESDAY",
"time": "14:00"
},
"end": {
"day": "WEDNESDAY",
"time": "16:00"
},
"mode": "AUTO",
"temperature": 21
},
{
"start": {
"day": "WEDNESDAY",
"time": "16:00"
},
"end": {
"day": "WEDNESDAY",
"time": "19:00"
},
"mode": "AUTO",
"temperature": 19
},
{
"start": {
"day": "WEDNESDAY",
"time": "19:00"
},
"end": {
"day": "WEDNESDAY",
"time": "19:30"
},
"mode": "AUTO",
"temperature": 20
},
{
"start": {
"day": "THURSDAY",
"time": "04:30"
},
"end": {
"day": "THURSDAY",
"time": "06:30"
},
"mode": "AUTO",
"temperature": 20
},
{
"start": {
"day": "THURSDAY",
"time": "14:00"
},
"end": {
"day": "THURSDAY",
"time": "16:00"
},
"mode": "AUTO",
"temperature": 21
},
{
"start": {
"day": "THURSDAY",
"time": "16:00"
},
"end": {
"day": "THURSDAY",
"time": "19:00"
},
"mode": "AUTO",
"temperature": 19
},
{
"start": {
"day": "THURSDAY",
"time": "19:00"
},
"end": {
"day": "THURSDAY",
"time": "19:30"
},
"mode": "AUTO",
"temperature": 20
},
{
"start": {
"day": "FRIDAY",
"time": "04:30"
},
"end": {
"day": "FRIDAY",
"time": "06:30"
},
"mode": "AUTO",
"temperature": 20
},
{
"start": {
"day": "FRIDAY",
"time": "14:00"
},
"end": {
"day": "FRIDAY",
"time": "16:00"
},
"mode": "AUTO",
"temperature": 21
},
{
"start": {
"day": "FRIDAY",
"time": "16:00"
},
"end": {
"day": "FRIDAY",
"time": "19:00"
},
"mode": "AUTO",
"temperature": 19
},
{
"start": {
"day": "FRIDAY",
"time": "19:00"
},
"end": {
"day": "FRIDAY",
"time": "19:30"
},
"mode": "AUTO",
"temperature": 20
},
{
"start": {
"day": "SATURDAY",
"time": "04:30"
},
"end": {
"day": "SATURDAY",
"time": "06:30"
},
"mode": "AUTO",
"temperature": 20
},
{
"start": {
"day": "SATURDAY",
"time": "14:00"
},
"end": {
"day": "SATURDAY",
"time": "16:00"
},
"mode": "AUTO",
"temperature": 21
},
{
"start": {
"day": "SATURDAY",
"time": "16:00"
},
"end": {
"day": "SATURDAY",
"time": "19:00"
},
"mode": "AUTO",
"temperature": 19
},
{
"start": {
"day": "SATURDAY",
"time": "19:00"
},
"end": {
"day": "SATURDAY",
"time": "19:30"
},
"mode": "AUTO",
"temperature": 20
},
{
"start": {
"day": "SUNDAY",
"time": "04:30"
},
"end": {
"day": "SUNDAY",
"time": "06:30"
},
"mode": "AUTO",
"temperature": 20
},
{
"start": {
"day": "SUNDAY",
"time": "14:00"
},
"end": {
"day": "SUNDAY",
"time": "16:00"
},
"mode": "AUTO",
"temperature": 21
},
{
"start": {
"day": "SUNDAY",
"time": "16:00"
},
"end": {
"day": "SUNDAY",
"time": "19:00"
},
"mode": "AUTO",
"temperature": 19
},
{
"start": {
"day": "SUNDAY",
"time": "19:00"
},
"end": {
"day": "SUNDAY",
"time": "19:30"
},
"mode": "AUTO",
"temperature": 20
}
]
}
```
```json HVAC Delete theme={null}
{
"id": "6eb5497d-c6bb-4290-84ef-4409fe9501f1",
"userId": "896f9d5a-b618-48a2-98ae-957059bf1bc9",
"locationId": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
"isOnline": true,
"staticData": {
"type": "AC",
"room": "Living room",
"vendor": "VIESSMANN",
"model": "Vitotronic 200",
"name": "Viessmann Vitotronic 200",
"capableModes": ["HEAT"],
"lastUpdated": "2025-01-02T10:24:02.447Z"
},
"climateState": {
"isActive": true,
"mode": "HEAT",
"temperatureCurrent": 20.3,
"temperatureOutside": 12,
"temperatureTargets": [
{
"mode": "HEAT",
"temperature": 18
}
],
"lastUpdated": "2025-01-02T10:24:02.447Z"
},
"powerState": {
"powerConsumption": 0,
"lastUpdated": "2025-01-02T10:24:02.447Z"
},
"lastUpdated": "2025-01-02T10:24:02.447Z"
}
```
```json HVAC Offline theme={null}
{
"id": "6eb5497d-c6bb-4290-84ef-4409fe9501f1",
"userId": "896f9d5a-b618-48a2-98ae-957059bf1bc9",
"locationId": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
"isOnline": false,
"staticData": {
"type": "AC",
"room": "Living room",
"vendor": "VIESSMANN",
"model": "Vitotronic 200",
"name": "Viessmann Vitotronic 200",
"capableModes": ["HEAT"],
"lastUpdated": "2025-01-02T10:24:02.447Z"
},
"climateState": {
"isActive": true,
"mode": "HEAT",
"temperatureCurrent": 20.3,
"temperatureOutside": 12,
"temperatureTargets": [
{
"mode": "HEAT",
"temperature": 18
}
],
"lastUpdated": "2025-01-02T10:24:02.447Z"
},
"powerState": {
"powerConsumption": 0,
"lastUpdated": "2025-01-02T10:24:02.447Z"
},
"lastUpdated": "2025-01-02T10:24:02.447Z"
}
```
```json HVAC Command theme={null}
{
"id": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
"userId": "896f9d5a-b618-48a2-98ae-957059bf1bc9",
"deviceId": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
"type": "SET_TEMPERATURE",
"state": "PENDING",
"createdAt": "2025-01-02T10:34:03.322Z"
}
```
```json HVAC Disconnect theme={null}
{
"deviceId": "0393521a-baf2-47f2-8071-6c64cfecf0a8",
"vendorAccountId": "e454420b-6705-42e3-a110-f40b0ba52629",
"userId": "a5ac2de6-fd9d-4df2-b01c-1ce77ee03c7b",
"vendor": "VIESSMANN",
"reason": "AUTHENTICATION_EXPIRED",
"resolution": "RECONNECT_DEVICE"
}
```
### Battery Streaming Message Examples
Batteries can send the following message types:
* `{subscriptionId}.battery.connect`
* `{subscriptionId}.battery.update`
* `{subscriptionId}.battery.delete`
* `{subscriptionId}.battery.offline`
```json Battery Connect theme={null}
{
"id": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
"userId": "896f9d5a-b618-48a2-98ae-957059bf1bc9",
"locationId": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
"isOnline": true,
"staticData": {
"vendor": "SMA",
"model": "Battery,
"name": "My device",
"batteryCapacity": 106,
"siteName": "Osna Lab",
"lastUpdated": "2025-01-02T10:45:20.980Z"
},
"chargeState": {
"mode": null,
"stateOfCharge": null,
"maxChargeRate": null,
"maxDischargeRate": null,
"chargeLimitMin": null,
"chargeLimitMax": null,
"chargeRate": null,
"chargingState": null,
"lastUpdated": null
},
"lastUpdated": "2025-01-02T10:45:20.980Z"
}
```
```json Battery Update theme={null}
{
"id": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
"userId": "896f9d5a-b618-48a2-98ae-957059bf1bc9",
"locationId": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
"isOnline": true,
"staticData": {
"vendor": "FRONIUS",
"model": "Battery",
"name": "My device",
"batteryCapacity": 106,
"siteName": "Osna Lab",
"lastUpdated": "2025-01-02T10:45:20.980Z"
},
"chargeState": {
"mode": "AUTO",
"stateOfCharge": 72,
"maxChargeRate": 6000,
"maxDischargeRate": 6000,
"chargeLimitMin": 20,
"chargeLimitMax": 80,
"chargeRate": 6.5,
"chargingState": "CHARGING",
"lastUpdated": "2025-01-02T10:45:20.980Z"
},
"lastUpdated": "2025-01-02T10:45:20.980Z"
}
```
```json Battery Delete theme={null}
{
"id": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
"userId": "896f9d5a-b618-48a2-98ae-957059bf1bc9",
"locationId": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
"isOnline": true,
"staticData": {
"vendor": "FRONIUS",
"model": "Battery",
"name": "My device",
"batteryCapacity": 106,
"siteName": "Osna Lab",
"lastUpdated": "2025-01-02T10:45:20.980Z"
},
"chargeState": {
"mode": "AUTO",
"stateOfCharge": 72,
"maxChargeRate": 6000,
"maxDischargeRate": 6000,
"chargeLimitMin": 20,
"chargeLimitMax": 80,
"chargeRate": 6.5,
"chargingState": "CHARGING",
"lastUpdated": "2025-01-02T10:45:20.980Z"
},
"lastUpdated": "2025-01-02T10:45:20.980Z"
}
```
```json Battery Offline theme={null}
{
"id": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
"userId": "896f9d5a-b618-48a2-98ae-957059bf1bc9",
"locationId": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
"isOnline": false,
"staticData": {
"vendor": "FRONIUS",
"model": "Battery",
"name": "My device",
"batteryCapacity": 106,
"siteName": "Osna Lab",
"lastUpdated": "2025-01-02T10:45:20.980Z"
},
"chargeState": {
"mode": "AUTO",
"stateOfCharge": 72,
"maxChargeRate": 6000,
"maxDischargeRate": 6000,
"chargeLimitMin": 20,
"chargeLimitMax": 80,
"chargeRate": 6.5,
"chargingState": "CHARGING",
"lastUpdated": "2025-01-02T10:45:20.980Z"
},
"lastUpdated": "2025-01-02T10:45:20.980Z"
}
```
```json Battery Disconnect theme={null}
{
"deviceId": "0393521a-baf2-47f2-8071-6c64cfecf0a8",
"vendorAccountId": "e454420b-6705-42e3-a110-f40b0ba52629",
"userId": "a5ac2de6-fd9d-4df2-b01c-1ce77ee03c7b",
"vendor": "TESLA",
"reason": "AUTHENTICATION_EXPIRED",
"resolution": "RECONNECT_DEVICE"
}
```
### PV-Inverter Streaming Message Examples
PV-Inverters can send the following message types:
* `{subscriptionId}.pv-inverter.connect`
* `{subscriptionId}.pv-inverter.update`
* `{subscriptionId}.pv-inverter.delete`
* `{subscriptionId}.pv-inverter.offline`
```json PV-Inverter Connect theme={null}
{
"id": "6eb5497d-c6bb-4290-84ef-4409fe9501f1",
"userId": "896f9d5a-b618-48a2-98ae-957059bf1bc9",
"locationId": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
"isOnline": true,
"staticData": {
"vendor": "FRONIUS",
"model": "Inverter",
"name": "My device",
"siteName": "Osna Lab",
"lastUpdated": "2025-01-02T10:53:42.719Z"
},
"powerState": {
"solarPower": null,
"state": null,
"lastUpdated": null
},
"lastUpdated": "2025-01-02T10:53:42.719Z"
}
```
```json PV-Inverter Update theme={null}
{
"id": "6eb5497d-c6bb-4290-84ef-4409fe9501f1",
"userId": "896f9d5a-b618-48a2-98ae-957059bf1bc9",
"locationId": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
"isOnline": true,
"staticData": {
"vendor": "FRONIUS",
"model": "Inverter",
"name": "My device",
"siteName": "Osna Lab",
"lastUpdated": "2025-01-02T10:53:42.719Z"
},
"powerState": {
"solarPower": 15.8,
"state": "PRODUCING",
"lastUpdated": "2025-01-02T10:53:42.719Z"
},
"lastUpdated": "2025-01-02T10:53:42.719Z"
}
```
```json PV-Inverter Delete theme={null}
{
"id": "6eb5497d-c6bb-4290-84ef-4409fe9501f1",
"userId": "896f9d5a-b618-48a2-98ae-957059bf1bc9",
"locationId": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
"isOnline": true,
"staticData": {
"vendor": "FRONIUS",
"model": "Inverter",
"name": "My device",
"siteName": "Osna Lab",
"lastUpdated": "2025-01-02T10:53:42.719Z"
},
"powerState": {
"solarPower": 15.8,
"state": "PRODUCING",
"lastUpdated": "2025-01-02T10:53:42.719Z"
},
"lastUpdated": "2025-01-02T10:53:42.719Z"
}
```
```json PV-Inverter Offline theme={null}
{
"id": "6eb5497d-c6bb-4290-84ef-4409fe9501f1",
"userId": "896f9d5a-b618-48a2-98ae-957059bf1bc9",
"locationId": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
"isOnline": false,
"staticData": {
"vendor": "FRONIUS",
"model": "Inverter",
"name": "My device",
"siteName": "Osna Lab",
"lastUpdated": "2025-01-02T10:53:42.719Z"
},
"powerState": {
"solarPower": 15.8,
"state": "PRODUCING",
"lastUpdated": "2025-01-02T10:53:42.719Z"
},
"lastUpdated": "2025-01-02T10:53:42.719Z"
}
```
```json PV-Inverter Disconnect theme={null}
{
"deviceId": "0393521a-baf2-47f2-8071-6c64cfecf0a8",
"vendorAccountId": "e454420b-6705-42e3-a110-f40b0ba52629",
"userId": "a5ac2de6-fd9d-4df2-b01c-1ce77ee03c7b",
"vendor": "TESLA",
"reason": "AUTHENTICATION_EXPIRED",
"resolution": "RECONNECT_DEVICE"
}
```
### Meter Streaming Message Examples
Meters can send the following message types:
* `{subscriptionId}.meter.connect`
* `{subscriptionId}.meter.update`
* `{subscriptionId}.meter.delete`
* `{subscriptionId}.meter.offline`
```json Meter Connect theme={null}
{
"id": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
"userId": "896f9d5a-b618-48a2-98ae-957059bf1bc9",
"locationId": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
"isOnline": true,
"staticData": {
"vendor": "FRONIUS",
"model": "Meter",
"name": "My device",
"siteName": "Osna Lab",
"lastUpdated": "2025-01-02T10:56:28.800Z"
},
"powerState": {
"power": null,
"meterValue": null,
"lastUpdated": null
},
"lastUpdated": "2025-01-02T10:56:28.800Z"
}
```
```json Meter Update theme={null}
{
"id": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
"userId": "896f9d5a-b618-48a2-98ae-957059bf1bc9",
"locationId": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
"isOnline": true,
"staticData": {
"vendor": "FRONIUS",
"model": "Meter",
"name": "My device",
"siteName": "Osna Lab",
"lastUpdated": "2025-01-02T10:56:28.800Z"
},
"powerState": {
"power": 15.8,
"meterValue": 289,
"lastUpdated": "2025-01-02T10:56:28.800Z"
},
"lastUpdated": "2025-01-02T10:56:28.800Z"
}
```
```json Meter Delete theme={null}
{
"id": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
"userId": "896f9d5a-b618-48a2-98ae-957059bf1bc9",
"locationId": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
"isOnline": true,
"staticData": {
"vendor": "FRONIUS",
"model": "Meter",
"name": "My device",
"siteName": "Osna Lab",
"lastUpdated": "2025-01-02T10:56:28.800Z"
},
"powerState": {
"power": 15.8,
"meterValue": 289,
"lastUpdated": "2025-01-02T10:56:28.800Z"
},
"lastUpdated": "2025-01-02T10:56:28.800Z"
}
```
```json Meter Offline theme={null}
{
"id": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
"userId": "896f9d5a-b618-48a2-98ae-957059bf1bc9",
"locationId": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
"isOnline": false,
"staticData": {
"vendor": "FRONIUS",
"model": "Meter",
"name": "My device",
"siteName": "Osna Lab",
"lastUpdated": "2025-01-02T10:56:28.800Z"
},
"powerState": {
"power": 15.8,
"meterValue": 289,
"lastUpdated": "2025-01-02T10:56:28.800Z"
},
"lastUpdated": "2025-01-02T10:56:28.800Z"
}
```
```json Meter Disconnect theme={null}
{
"deviceId": "0393521a-baf2-47f2-8071-6c64cfecf0a8",
"vendorAccountId": "e454420b-6705-42e3-a110-f40b0ba52629",
"userId": "a5ac2de6-fd9d-4df2-b01c-1ce77ee03c7b",
"vendor": "TESLA",
"reason": "AUTHENTICATION_EXPIRED",
"resolution": "RECONNECT_DEVICE"
}
```
***
# Introduction
Source: https://developer.energy-hub.io/documentation/streaming/introduction
Once an energy device or service has been successfully connected to the Energy Hub Alliance, it generates streaming messages that can be received by connecting your application to the streaming service. Currently, the supported streaming technology is Kafka.
Traffic between the Kafka consumer and the EHA Kafka broker is transported via the TLS protocol. An additional security measure is the use of the SASL protocol for authentication. Therefore, the Kafka consumer must be configured with multiple parameters to connect to and read notifications from the EHA streaming service. Specifically, the `SASL_SSL` security protocol supported by Kafka is used.
To consume messages, you need a Kafka message consumer, proper consumer configuration, credentials, and your client system must trust the Let’s Encrypt trust chain. The consumer configuration includes the URL of the EHA broker, the topic name, and the credentials. Topics are separated by subscription ID, and security policies ensure that only you can access your subscriptions.
Each topic you can receive notifications from is dedicated to a specific subscription. Therefore, you must request specific streaming client credentials for each subscription. Once you have collected all the streaming credentials for a subscription, you will be able to connect to all its associated topics.
Streaming credentials are obtained via the Partner Portal.
### Authentication
The EHA streaming service supports OAuth for authentication across all its Kafka topics. The EHA Kafka broker supports `SASL/OAUTHBEARER` authentication — a SASL-based mechanism for authenticating clients using OAuth tokens based on the JSON Web Token (JWT) standard, as specified in [RFC 7519](https://datatracker.ietf.org/doc/html/rfc7519). You can use the [SASL/OAUTHBEARER mechanism](https://kafka.apache.org/documentation/#security_sasl_oauthbearer) to authenticate your Kafka clients.
# Overview
Source: https://developer.energy-hub.io/documentation/vendor-capabilities/overview
The Energy Hub Alliance lets you connect all kinds of energy vendors to your application. This page lists the currently available integrations and their capabilities.
This list is continually updated. Vendors or capabilities with the “coming
soon” symbol are usually released within 6-13 weeks.
### Vehicles
| Vendor | Static Data | Vehicle Image | Location | Odometer | Charge State | Climate State | Control Charging |
| --------------- | :---------: | :-----------: | :------: | :------: | :----------: | :-----------: | :--------------: |
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
### Smart tariffs
| Vendor | Static Data | Prices | Consumption |
| --------------- | :---------: | :-----: | :---------: |
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
### Heating, Ventilation, and Air Conditioning (HVAC) Devices
| Vendor | Static Data | Climate State | Power State | Schedules | Control Climate State |
| ------- | :---------: | :-----------: | :---------: | :-------: | :-------------------: |
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
### EV Chargers
| Vendor | Static Data | Charge State | Control Charging |
| --------------- | :---------: | :----------: | :--------------: |
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
### Home Power Devices (Inverters, Batteries & Meters)
| Vendor | Static Data | Battery Charge State | Power State |
| ------- | :---------: | :------------------: | :---------: |
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
|
***
Available
Not offered by vendor
Coming soon
# Audi
Source: https://developer.energy-hub.io/documentation/vendor-capabilities/vendors/audi
## Supported Devices
Contact support for specific models.
## Supported Data Fields
| Field Name | Description | Supported |
| ---------------------------------------- | ----------------------------------------------------- | --------- |
| `chargeState.chargeRate` | Current charging power/rate . | ✓ |
| `chargeState.chargeCurrentMax` | Maximum charging current that the vehicle can accept. | ✓ |
| `chargeState.lastUpdated` | Timestamp for the chargeState snapshot. | ✓ |
| `chargeState.stateOfCharge` | Battery state of charge in percent. | ✓ |
| `chargeState.chargingTimeRemaining` | Estimated time remaining to finish charging . | ✓ |
| `chargeState.chargeLimitMin` | Minimum charge limit set (percent). | ✗ |
| `chargeState.chargeLimitMax` | Maximum charge limit set (percent). | ✓ |
| `chargeState.scheduledDepartureTime` | Scheduled departure time, if set. | ✓ |
| `chargeState.scheduledChargingStartTime` | Scheduled charging start time, if set. | ✓ |
| `chargeState.estimatedRange` | Estimated remaining driving range . | ✓ |
| `chargeState.chargingState` | Charging status enum (e.g., CHARGING, STOPPED, etc.). | ✓ |
| `chargeState.isPlugged` | Indicates if the charger is plugged into the car. | ✓ |
| `chargeState.remoteChargingAllowed` | If charging control is allowed. | ✓ |
| `odometer.lastUpdated` | Timestamp for the odometer snapshot. | ✓ |
| `odometer.odometer` | Vehicle odometer reading . | ✓ |
| `isOnline` | Whether the vehicle is currently online/reachable. | ✓ |
| `location.lastUpdated` | Timestamp for the location snapshot. | ✓ |
| `location.latitude` | Latitude coordinate. | ✓ |
| `location.longitude` | Longitude coordinate. | ✓ |
| `climateState.lastUpdated` | Timestamp for the climateState snapshot. | ✗ |
| `climateState.isClimateOn` | Whether cabin climate is currently on. | ✗ |
| `climateState.isBatteryHeaterOn` | Whether the battery heater is on. | ✗ |
| `climateState.temperatureCurrent` | Current cabin temperature. | ✗ |
| `climateState.temperatureTarget` | Target cabin temperature. | ✗ |
| `staticData.lastUpdated` | Timestamp for the staticData snapshot. | ✓ |
| `staticData.vendor` | Vehicle vendor/manufacturer | ✓ |
| `staticData.name` | Friendly/display name for the vehicle. | ✗ |
| `staticData.engineType` | Engine/fuel type (e.g., BEV, PHEV). | ✗ |
| `staticData.vin` | Vehicle Identification Number. | ✓ |
| `staticData.model` | Model name. | ✗ |
| `staticData.batteryCapacity` | Battery capacity. | ✓ |
| `staticData.vehicleVariant` | Trim/variant designation. | ✗ |
## Supported Commands
| Command Name | Short description | Supported |
| -------------- | ----------------------------------------- | --------- |
| Start Charging | Starts the charging process. | ✓ |
| Stop Charging | Stops the charging process. | ✓ |
| Schedules | Sets a charging schedule for the vehicle. | ✓ |
## Data Update Interval
| State | Refresh Rate |
| -------- | ------------ |
| Idle | varies |
| Driving | \< 1 min |
| Charging | \< 1 min |
# BMW
Source: https://developer.energy-hub.io/documentation/vendor-capabilities/vendors/bmw
## Supported Devices
| Model | Limitations |
| ----- | ----------- |
| 225xe | - |
| 330e | - |
| 530e | - |
| 740e | - |
| 740Le | - |
| 745e | - |
| 745Le | - |
| 750e | - |
| i3 | - |
| i4 | - |
| i5 | - |
| i7 | - |
| i8 | - |
| iX | - |
| iX1 | - |
| iX2 | - |
| iX3 | - |
| M5 | - |
| M760e | - |
| X1 | - |
| X2 | - |
| X3 | - |
| X5 | - |
| XM | - |
## Supported Data Fields
| Field Name | Description | Supported |
| ---------------------------------------- | ----------------------------------------------------- | --------- |
| `chargeState.chargeRate` | Current charging power/rate . | ✓ |
| `chargeState.chargeCurrentMax` | Maximum charging current that the vehicle can accept. | ✓ |
| `chargeState.lastUpdated` | Timestamp for the chargeState snapshot. | ✓ |
| `chargeState.stateOfCharge` | Battery state of charge in percent. | ✓ |
| `chargeState.chargingTimeRemaining` | Estimated time remaining to finish charging . | ✓ |
| `chargeState.chargeLimitMin` | Minimum charge limit set (percent). | ✗ |
| `chargeState.chargeLimitMax` | Maximum charge limit set (percent). | ✓ |
| `chargeState.scheduledDepartureTime` | Scheduled departure time, if set. | ✓ |
| `chargeState.scheduledChargingStartTime` | Scheduled charging start time, if set. | ✗ |
| `chargeState.estimatedRange` | Estimated remaining driving range . | ✓ |
| `chargeState.chargingState` | Charging status enum (e.g., CHARGING, STOPPED, etc.). | ✓ |
| `chargeState.isPlugged` | Indicates if the charger is plugged into the car. | ✓ |
| `chargeState.remoteChargingAllowed` | If charging control is allowed. | ✓ |
| `odometer.lastUpdated` | Timestamp for the odometer snapshot. | ✗ |
| `odometer.odometer` | Vehicle odometer reading . | ✗ |
| `isOnline` | Whether the vehicle is currently online/reachable. | ✓ |
| `location.lastUpdated` | Timestamp for the location snapshot. | ✗ |
| `location.latitude` | Latitude coordinate. | ✗ |
| `location.longitude` | Longitude coordinate. | ✗ |
| `climateState.lastUpdated` | Timestamp for the climateState snapshot. | ✓ |
| `climateState.isClimateOn` | Whether cabin climate is currently on. | ✓ |
| `climateState.isBatteryHeaterOn` | Whether the battery heater is on. | ✗ |
| `climateState.temperatureCurrent` | Current cabin temperature. | ✗ |
| `climateState.temperatureTarget` | Target cabin temperature. | ✗ |
| `staticData.lastUpdated` | Timestamp for the staticData snapshot. | ✓ |
| `staticData.vendor` | Vehicle vendor/manufacturer | ✓ |
| `staticData.name` | Friendly/display name for the vehicle. | ✓ |
| `staticData.engineType` | Engine/fuel type (e.g., BEV, PHEV). | ✗ |
| `staticData.vin` | Vehicle Identification Number. | ✗ |
| `staticData.model` | Model name. | ✓ |
| `staticData.batteryCapacity` | Battery capacity. | ✓ |
| `staticData.vehicleVariant` | Trim/variant designation. | ✗ |
## Supported Commands
| Command Name | Short description | Supported |
| -------------- | ----------------------------------------- | --------- |
| Start Charging | Starts the charging process. | ✓ |
| Stop Charging | Stops the charging process. | ✓ |
| Schedules | Sets a charging schedule for the vehicle. | ✓ |
## Data Update Interval
| State | Refresh Rate |
| -------- | ------------ |
| Idle | 15 min |
| Driving | 15 min |
| Charging | 5 min |
# Cupra
Source: https://developer.energy-hub.io/documentation/vendor-capabilities/vendors/cupra
## Supported Devices
| Model | Limitations |
| ----- | ----------- |
| Born | - |
## Supported Data Fields
| Field Name | Description | Supported |
| ---------------------------------------- | ----------------------------------------------------- | --------- |
| `chargeState.chargeRate` | Current charging power/rate . | ✓ |
| `chargeState.chargeCurrentMax` | Maximum charging current that the vehicle can accept. | ✓ |
| `chargeState.lastUpdated` | Timestamp for the chargeState snapshot. | ✓ |
| `chargeState.stateOfCharge` | Battery state of charge in percent. | ✓ |
| `chargeState.chargingTimeRemaining` | Estimated time remaining to finish charging . | ✓ |
| `chargeState.chargeLimitMin` | Minimum charge limit set (percent). | ✗ |
| `chargeState.chargeLimitMax` | Maximum charge limit set (percent). | ✓ |
| `chargeState.scheduledDepartureTime` | Scheduled departure time, if set. | ✓ |
| `chargeState.scheduledChargingStartTime` | Scheduled charging start time, if set. | ✓ |
| `chargeState.estimatedRange` | Estimated remaining driving range . | ✓ |
| `chargeState.chargingState` | Charging status enum (e.g., CHARGING, STOPPED, etc.). | ✓ |
| `chargeState.isPlugged` | Indicates if the charger is plugged into the car. | ✓ |
| `chargeState.remoteChargingAllowed` | If charging control is allowed. | ✓ |
| `odometer.lastUpdated` | Timestamp for the odometer snapshot. | ✓ |
| `odometer.odometer` | Vehicle odometer reading . | ✓ |
| `isOnline` | Whether the vehicle is currently online/reachable. | ✓ |
| `location.lastUpdated` | Timestamp for the location snapshot. | ✓ |
| `location.latitude` | Latitude coordinate. | ✓ |
| `location.longitude` | Longitude coordinate. | ✓ |
| `climateState.lastUpdated` | Timestamp for the climateState snapshot. | ✗ |
| `climateState.isClimateOn` | Whether cabin climate is currently on. | ✗ |
| `climateState.isBatteryHeaterOn` | Whether the battery heater is on. | ✗ |
| `climateState.temperatureCurrent` | Current cabin temperature. | ✗ |
| `climateState.temperatureTarget` | Target cabin temperature. | ✗ |
| `staticData.lastUpdated` | Timestamp for the staticData snapshot. | ✓ |
| `staticData.vendor` | Vehicle vendor/manufacturer | ✓ |
| `staticData.name` | Friendly/display name for the vehicle. | ✗ |
| `staticData.engineType` | Engine/fuel type (e.g., BEV, PHEV). | ✗ |
| `staticData.vin` | Vehicle Identification Number. | ✓ |
| `staticData.model` | Model name. | ✗ |
| `staticData.batteryCapacity` | Battery capacity. | ✓ |
| `staticData.vehicleVariant` | Trim/variant designation. | ✗ |
## Supported Commands
| Command Name | Short description | Supported |
| -------------- | ----------------------------------------- | --------- |
| Start Charging | Starts the charging process. | ✓ |
| Stop Charging | Stops the charging process. | ✓ |
| Schedules | Sets a charging schedule for the vehicle. | ✓ |
## Data Update Interval
| State | Refresh Rate |
| -------- | ------------ |
| Idle | varies |
| Driving | \< 1 min |
| Charging | \< 1 min |
# MINI
Source: https://developer.energy-hub.io/documentation/vendor-capabilities/vendors/mini
## Supported Devices
| Model | Limitations |
| ----------------------------- | ----------- |
[...]
